unit UnitFrmConfig;
{
    Purpose:
        This form configures the hotkey as well as receives messages
        when the hotkey is pressed.

        This form also reads the current configuration and passes those
        option onto the responsible form (mainly FrmMainPopup)

    Updates:
        New panel for Popup "Config -> Popup - Keystrokes"
        Updated for option to show popup on double-click
        Removed Items now saved << no longer needed with cached removed items


        --------------
        New Form Mode show option
        Fixed logic for "Show Permanent Items" and selecting a
        display method.
        ------------
        New "SHIFT+INSERT" pasting options
        
        Moved the popup "show" options to their own panel
        New "Show Options" subitem under Popup
        New user definable function key for copy & permanent
        popup keystrokes.


        New Clipboard option - "Disable clipboard Monitoring when Scroll Lock is on"

        New look
        New way to do hotkeys

        Used ini.ReadInteger where appropriate
        Using UnitClipQueue
}
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls, ImgList, UnitHotKey, UnitFrmPermanentNew,
  Buttons;


type FormatOrder = (FO_UNICODE, FO_HTML, FO_RICHTEXT);
type TMenuOrderType =
(
    MOT_MENU,
    MOT_OTHER,
    MOT_CANCEL,
    MOT_LAST,
    MOT_CURRENT,
    MOT_REMOVED,
    MOT_PROGRAM,
    MOT_SYSTEM,
    MOT_MISC,
    MOT_PERMANENT,
    MOT_SWITCH,
    MOT_FULL,
    MOT_ALLITEMS,
    MOT_SELECTED,
    MOT_CLICKED,
    MOT_SEARCH,
    MOT_BREAK
);

type
  TFrmConfig = class(TForm)
    btnSave: TButton;
    btnCancel: TButton;
    ImageList1: TImageList;
    FontDialog: TFontDialog;
    Panel10: TPanel;
    tvOptions: TTreeView;
    pcPanels: TPageControl;
    TabSheet1: TTabSheet;
    pHotkey: TPanel;
    Shape6: TShape;
    Shape1: TShape;
    lblKeyname: TLabel;
    Label5: TLabel;
    Label23: TLabel;
    lblPlaintext: TLabel;
    bEditPopupHotkey: TButton;
    btnEditPlaintextHotkey: TButton;
    Panel8: TPanel;
    Panel9: TPanel;
    Shape2: TShape;
    Label12: TLabel;
    lblTooltipKeyname: TLabel;
    Shape3: TShape;
    Label16: TLabel;
    lblPreviousTooltipKeyname: TLabel;
    cbUseTooltipHotkey: TCheckBox;
    bEditToolTipHotkey: TButton;
    bEditPreviousToolTipHotkey: TButton;
    TabSheet2: TTabSheet;
    pClipboard: TPanel;
    Label1: TLabel;
    Label38: TLabel;
    cbCopyIcons: TCheckBox;
    cbDisable: TCheckBox;
    cbDisableWhenScrollLock: TCheckBox;
    cbDisableSystemTrayIconNotification: TCheckBox;
    cbRemember: TCheckBox;
    cbDisableChainNotification: TCheckBox;
    txtOldHistorySize: TEdit;
    udRemovedSize: TUpDown;
    cbEnableExtendedChainChecking: TCheckBox;
    cbDisableWatcher: TCheckBox;
    TabSheet3: TTabSheet;
    pClipboard_TextItems: TPanel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    Label24: TLabel;
    Label34: TLabel;
    cbMonitorFilenames: TCheckBox;
    cbMoveDuplicate: TCheckBox;
    lvFormats: TListView;
    cbRemoveFormat: TCheckBox;
    cbAutofixURLs: TCheckBox;
    cbCaseSensitive: TCheckBox;
    TabSheet4: TTabSheet;
    pClipboard_NonText: TPanel;
    Label8: TLabel;
    Label9: TLabel;
    Label35: TLabel;
    cbOtherItems: TCheckBox;
    txtOtherSizeLimitKB: TEdit;
    TabSheet5: TTabSheet;
    pPasting: TPanel;
    Label3: TLabel;
    rbTyping: TRadioButton;
    rbPaste: TRadioButton;
    rbClipboardOnly: TRadioButton;
    Panel1: TPanel;
    Label4: TLabel;
    rbOtherClipboardOnly: TRadioButton;
    rbOtherPaste: TRadioButton;
    rbPasteSI: TRadioButton;
    cbPasteComplex: TCheckBox;
    TabSheet6: TTabSheet;
    pPopup: TPanel;
    Label17: TLabel;
    Image1: TImage;
    Label31: TLabel;
    cbMoveFirst: TCheckBox;
    cbPopupDoubleclick: TCheckBox;
    cbPopupDoubleclickTray: TCheckBox;
    cbDisplayAtMouseCursor: TCheckBox;
    cbPopupSingleclickTray: TCheckBox;
    cbPopupSingleclick: TCheckBox;
    bntSetFont: TButton;
    txtWidth: TEdit;
    UDWidth: TUpDown;
    cbUseKeyboard: TCheckBox;
    TabSheet9: TTabSheet;
    Panel4: TPanel;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    Label25: TLabel;
    Label30: TLabel;
    lvOrder: TListView;
    Button1: TButton;
    TabSheet7: TTabSheet;
    pPopupShow: TPanel;
    Label27: TLabel;
    Label26: TLabel;
    Panel5: TPanel;
    cbShowAllItems: TRadioButton;
    cbShowAllAsSubmenus: TRadioButton;
    Panel3: TPanel;
    cbShowPermanentItemGroups: TRadioButton;
    cbPermanentItemsSubmenu: TRadioButton;
    TabSheet8: TTabSheet;
    pPopupKeystrokes: TPanel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label36: TLabel;
    cboCopyClickKey: TComboBox;
    cboPermanentClickKey: TComboBox;
    cboMimicClickKey: TComboBox;
    Panel2: TPanel;
    rbCtrlClickRun: TRadioButton;
    rbCtrlClickMenu: TRadioButton;
    TabSheet12: TTabSheet;
    Panel7: TPanel;
    Label6: TLabel;
    Label32: TLabel;
    Edit1: TEdit;
    UDToolHeight: TUpDown;
    Edit2: TEdit;
    UDToolWidth: TUpDown;
    TabSheet10: TTabSheet;
    pTooltipPopup: TPanel;
    Label37: TLabel;
    cbFullHeader: TCheckBox;
    cbCopyVisibleItem: TCheckBox;
    TabSheet11: TTabSheet;
    Panel6: TPanel;
    Label28: TLabel;
    Label29: TLabel;
    cbShowEditInstead: TCheckBox;
    Panel11: TPanel;
    Label18: TLabel;
    txtQueueSize: TEdit;
    udQueueSize: TUpDown;
    Label2: TLabel;
    Label33: TLabel;
    txtOtherSize: TEdit;
    udOtherSize: TUpDown;
    Label7: TLabel;
    Label19: TLabel;
    txtRecentlyRemoved: TEdit;
    udRecentlyRemoved: TUpDown;
    Label20: TLabel;
    Label21: TLabel;
    txtMinHeight: TEdit;
    udMinHeight: TUpDown;
    cbDontCopySelectedForAll: TCheckBox;
    cbEnableSound: TCheckBox;
    tvGroup: TTreeView;
    ImageList2: TImageList;
    Label22: TLabel;
    Label39: TLabel;
    cbRightTriggerEnable: TCheckBox;
    cbSeparateNontextList: TCheckBox;
    Label40: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure cbKeyChange(Sender: TObject);
    procedure cbUseKeyboardClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure txtQueueSizeKeyPress(Sender: TObject; var Key: Char);
    procedure udQueueSizeClick(Sender: TObject; Button: TUDBtnType);
    procedure cbDisableClick(Sender: TObject);
    procedure btnEditPermanentItemsClick(Sender: TObject);
    procedure rbTypingClick(Sender: TObject);
    procedure rbPasteClick(Sender: TObject);
    procedure btnSaveClick(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure cbMonitorFilenamesClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure cbPasteAllClick(Sender: TObject);
    procedure rbClipboardOnlyClick(Sender: TObject);
    procedure cbMoveFirstClick(Sender: TObject);
    procedure udCharactersClick(Sender: TObject; Button: TUDBtnType);
    procedure cbRememberClick(Sender: TObject);
    procedure cbCopyIconsClick(Sender: TObject);
    procedure cbMoveDuplicateClick(Sender: TObject);
    procedure txtOldHistorySizeKeyPress(Sender: TObject; var Key: Char);
    procedure udRemovedSizeClick(Sender: TObject; Button: TUDBtnType);
    procedure cbOtherItemsClick(Sender: TObject);
    procedure txtOtherSizeKeyPress(Sender: TObject; var Key: Char);
    procedure txtOtherSizeLimitKBChange(Sender: TObject);
    procedure udOtherSizeClick(Sender: TObject; Button: TUDBtnType);
    procedure tvOptionsClick(Sender: TObject);
    procedure tvOptionsCollapsing(Sender: TObject; Node: TTreeNode;
      var AllowCollapse: Boolean);
    procedure bEditPopupHotkeyClick(Sender: TObject);
    procedure cbDisableWhenScrollLockClick(Sender: TObject);
    procedure cbShowEditHistoryClick(Sender: TObject);
    procedure cbDisableSystemTrayIconNotificationClick(Sender: TObject);
    procedure cboCopyClickKeyClick(Sender: TObject);
    procedure cboPermanentClickKeyClick(Sender: TObject);
    procedure rbPasteSIClick(Sender: TObject);
    procedure cboMimicClickKeyClick(Sender: TObject);
    procedure rbCtrlClickRunClick(Sender: TObject);
    procedure rbCtrlClickMenuClick(Sender: TObject);
    procedure tvOptionsChange(Sender: TObject; Node: TTreeNode);
    procedure cbShowFormModeClick(Sender: TObject);
    procedure bEditToolTipHotkeyClick(Sender: TObject);
    procedure bEditPreviousToolTipHotkeyClick(Sender: TObject);
    procedure cbPopupDoubleclickClick(Sender: TObject);
    procedure cbPopupDoubleclickTrayClick(Sender: TObject);
    procedure bntSetFontClick(Sender: TObject);
    procedure XcbShowAllItemsClick(Sender: TObject);
    procedure XcbShowAllAsSubmenusClick(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure txtRecentlyRemovedChange(Sender: TObject);
    procedure btnEditPlaintextHotkeyClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure cbDisableWatcherClick(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure lvOrderInfoTip(Sender: TObject; Item: TListItem;
      var InfoTip: string);
    procedure Panel8Click(Sender: TObject);
    procedure cbEnableSoundClick(Sender: TObject);
    procedure tvGroupMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure cbRightTriggerEnableClick(Sender: TObject);




  private
    { Private declarations }
    HotKeyPopup : TACHotKey;
    TTHotKeyPopup : TACHotKey;
    PTTHotKeyPopup : TACHotKey;
    PlainTextHotKey : TACHotKey;
    PlainTextData : THotkeyData;
    //LastShownPanel : TPanel;

    Hotkey_Ctrl : boolean;
    Hotkey_Alt : boolean;
    Hotkey_Winkey : boolean;
    Hotkey_Shift : boolean;
    Hotkey_Key :  word;

    TTHotkey_Ctrl : boolean;
    TTHotkey_Alt : boolean;
    TTHotkey_Winkey : boolean;
    TTHotkey_Shift : boolean;
    TTHotkey_Key :  word;

    PTTHotkey_Ctrl : boolean;
    PTTHotkey_Alt : boolean;
    PTTHotkey_Winkey : boolean;
    PTTHotkey_Shift : boolean;
    PTTHotkey_Key :  word;

    PreCaptureDelayMS : integer;
    RightClickDelay : integer;
    OldTrayPopup : boolean;
    CopySelected : boolean;

    RightclickTriggerWarned : boolean;
    PasteDelay : integer;
    ClipboardBarVisible : boolean;


    DefaultMenuOrder : array[TMenuOrderType] of integer;
    procedure HotkeySave;
    procedure HotkeyLoad;
    function GetINIFileName: string;
    {function HotKeyAssign(
            Ctrl: boolean; Alt: boolean; Shift: boolean; WinKey: boolean;
            Keystroke: word; FunctionKey : boolean): boolean;
    //function HotKeyRelease(): boolean;
    }
    function GetHumanReadableTTHotkey : string;
    function GetHumanReadablePTTHotkey : string;
    function GetHumanReadablePlaintextHotkey : string;
    {function SetHotKey : boolean;}


  public
    function GetHumanReadableHotkey: string;

    function GetRightclickTriggerWarned : boolean;
    function GetPasteDelay : integer;
    procedure SetRightclickTriggerWarned;
    function GetPreCaptureDelayMS : integer;
    function GetRightClickDelay : integer;
    function GetHotKeyID: integer;
    function GetTTHotKeyID: integer;
    function GetPTTHotKeyID: integer;
    function GetPlaintextHokeyID : integer;
    function GetOldTrayPopup : boolean;
    procedure ForceOldTrayPopup; 
    procedure SaveLastPermPath;

    function FormatCount : integer;
    function MenuOrderText(m : TMenuOrderType; description:boolean) : string;
    function GetFormat(index : integer) : FormatOrder;

    function CopySelectedForPopup : boolean;

    function ClipboardBarSetVisible : boolean;

    procedure SaveClipboardBarState;
    procedure LoadClipboardBarState;

    { Public declarations }
  end;

var
  FrmConfig: TFrmConfig;

implementation

uses
    INIFiles,

    UnitFrmMainPopup, UnitClipQueue, UnitOtherQueue, UnitFrmHotKey,
  UnitFrmSysTrayMenu, UnitFrmRemoved, UnitPaste,
  UnitMisc, UnitfrmDummyUnicodePopup, UnitFrmClipboardManager,
  UnitFrmChainWatcher
  , UnitPopupGenerate, UnitSound, UnitFrmDummyClipboardBar;




{$R *.dfm}

CONST LVORDER_ID = '2';



{
--========================
-- // Hook/ Release    //
--========================

}
procedure TFrmConfig.FormCreate(Sender: TObject);
var tn : TTreeNode;
    i : integer;
    li : TListItem;

    function NewOrderItem(mo : TMenuOrderType; line : boolean) : TListItem;
    begin
        result := lvOrder.items.add;
        result.Caption := MenuOrderText(mo, false);
        
        if line then
            result.SubItems.Add('Yes')
        else
            result.SubItems.Add('no');

        result.Data := Pointer(mo);
        result.Checked := (MO <> MOT_BREAK);

        DefaultMenuOrder[mo] := result.Index;
    end;
begin
    UnitMisc.AppendLog('FrmConfig - Creating');

    lvFormats.Items.Count := -1;
    Application.ProcessMessages;
    // BUG - this invalidates the listview count by sending the message LVSICF_NOINVALIDATEALL


    // set default Popup state
    lvOrder.Items.Clear;
    li := NewOrderItem(MOT_MENU, false);
    li := NewOrderItem(MOT_OTHER, true);
    li := NewOrderItem(MOT_CANCEL, true);
    li := NewOrderItem(MOT_CURRENT, true);
    li := NewOrderItem(MOT_SELECTED, false);
    self.CopySelected := true;
    li := NewOrderItem(MOT_LAST, false);
    li := NewOrderItem(MOT_REMOVED, true);
    li := NewOrderItem(MOT_SEARCH, false);
    li := NewOrderITem(MOT_CLICKED, false);
    li := NewOrderItem(MOT_PROGRAM, false);
    li := NewOrderItem(MOT_SYSTEM, false);
    li := NewOrderItem(MOT_BREAK, false);
    li := NewOrderItem(MOT_MISC, false);
    li := NewOrderItem(MOT_PERMANENT, true);
    li := NewOrderItem(MOT_ALLITEMS, false);
    li := NewOrderItem(MOT_SWITCH, false);
    li := NewOrderItem(MOT_FULL, true);
    lvOrder.items.Count := -1;
    Application.ProcessMessages;


    for i := 0 to lvOrder.items.Count - 1 do begin
        tn := tvGroup.Items.Add(nil, lvOrder.items[i].Caption);
        tn.ImageIndex := 1;
        tn.SelectedIndex := 1;
        tn.Data := lvOrder.items[i].data;
    end;


    self.HotkeyLoad();
    if not (cbPermanentItemsSubmenu.Checked or cbShowPermanentItemGroups.checked) then begin
        cbPermanentItemsSubmenu.Checked := true;
    end;

    if frmClipboardManager <> nil then begin
        if frmClipboardManager.IsNewClipboardAPI then begin
            cbDisableWatcher.Checked := true;
            cbDisableWatcher.Enabled := false;
            cbEnableExtendedChainChecking.Checked := false;
            cbEnableExtendedChainChecking.Enabled := false;
            cbDisableChainNotification.Checked := true;
            cbDisableChainNotification.Enabled := false;
        end;
    end;


    //
    //Hook onto keystoke
    //
    TTHotKeyPopup := nil;
    PTTHotKeyPopup := nil;
    PlainTextHotKey := nil;
    try
        HotKeyPopup := TACHotKey.Create(FrmMainPopup.handle, 'ArsClip.exe.MyHotKey',
            Hotkey_Ctrl, Hotkey_Alt, Hotkey_Shift,
            Hotkey_Winkey, Hotkey_Key
        );
    except
        ShowMessage('Failed to set hotkey ' + self.lblKeyname.Caption );
    end;
    try
        PlainTextHotkey:= TACHotKey.Create(FrmMainPopup.handle, 'ArsClip.exe.PlainText',
            PlainTextData.Ctrl, PlainTextData.Alt, PlainTextData.Shft,
            PlainTextData.Win, PlainTextData.Key
        );
    except
        ShowMessage('Failed to set hotkey ' + self.lblPlaintext.Caption );
    end;
    try
        if (self.cbUseTooltipHotkey.checked) then begin
            TTHotKeyPopup := TACHotKey.Create(FrmMainPopup.handle, 'ArsClip.exe.MyTTHotKey',
                TTHotkey_Ctrl, TTHotkey_Alt, TTHotkey_Shift,
                TTHotkey_Winkey, TTHotkey_Key
            );
        end;
    except
        ShowMessage('Failed to set hotkey ' + self.lblTooltipKeyname.Caption );
    end;
    try
        if (self.cbUseTooltipHotkey.checked) then begin
            PTTHotKeyPopup := TACHotKey.Create(FrmMainPopup.handle, 'ArsClip.exe.MyPTTHotKey',
                PTTHotkey_Ctrl, PTTHotkey_Alt, PTTHotkey_Shift,
                PTTHotkey_Winkey, PTTHotkey_Key
            );
        end;
    except
        ShowMessage('Failed to set hotkey ' + self.lblPreviousTooltipKeyname.Caption );
    end;


    {
    if (rbKey.Checked) then begin
        w := ord(txtKey.text[1]);
    end else begin
        w := Hotkey_Key;
    end;
    {
    if not self.HotKeyAssign(Hotkey_Ctrl, Hotkey_Alt, Hotkey_Shift,
        Hotkey_Winkey, Hotkey_Key, false) then begin
        ShowMessage('ERROR: Unable to assign a hotkey. Please change the key.');
    end;
    }

    // expand all tree branches
    tn := tvOptions.Items.GetFirstNode;
    while tn <> nil do begin
        if tn.HasChildren then
            tn.expand(true);
        tn := tn.getNextSibling;
    end;

    for i := 0 to pcPanels.PageCount - 1 do begin
        pcPanels.Pages[i].TabVisible := false;
    end;

    // click the first node by default
    tvOptions.Selected := tvOptions.Items.GetFirstNode;
    tvOptions.HideSelection := false;
    tvOptions.OnClick(self);


end;


procedure TFrmConfig.FormDestroy(Sender: TObject);
begin
    MyFree(HotKeyPopup);
    MyFree(TTHotKeyPopup);
    MyFree(PTTHotKeyPopup);
end;

procedure TFrmConfig.FormShow(Sender: TObject);
begin
    Windows.SetForegroundWindow(self.Handle);
end;





function TFrmConfig.GetHotKeyID: integer;
begin
    result := HotKeyPopup.GetID;
end;
function TFrmConfig.GetTTHotKeyID: integer;
begin
    result := -1;
    if TTHotKeyPopup <> nil then
        result := TTHotKeyPopup.GetID;
end;

function TFrmConfig.GetPTTHotKeyID: integer;
begin
    result := -1;
    if PTTHotKeyPopup <> nil then
        result := PTTHotKeyPopup.GetID;
end;


function TFrmConfig.GetRightClickDelay: integer;
begin
    result := self.RightClickDelay;
end;

function TFrmConfig.GetRightclickTriggerWarned: boolean;
begin
    result := self.RightclickTriggerWarned;
end;

function TFrmConfig.GetPasteDelay: integer;
begin
    result := self.PasteDelay;
end;

function TFrmConfig.GetPlaintextHokeyID: integer;
begin
    result := -1;
    if PlainTextHotKey <> nil then
        result := PlainTextHotKey.GetID;
end;


function TFrmConfig.GetHumanReadableHotkey : string;
var b : boolean;
begin
    result := '';
    if assigned(frmhotkey) then

    result := FrmHotkey.GetHumanReadable(Hotkey_alt, Hotkey_shift, Hotkey_ctrl, Hotkey_winkey, Hotkey_key, b);
end;


function TFrmConfig.GetHumanReadableTTHotkey : string;
var b : boolean;
begin
    result := FrmHotkey.GetHumanReadable(TTHotkey_alt, TTHotkey_shift, TTHotkey_ctrl, TTHotkey_winkey, TTHotkey_key, b);
end;

function TFrmConfig.GetHumanReadablePTTHotkey: string;
var b : boolean;
begin
    result := FrmHotkey.GetHumanReadable(PTTHotkey_alt, PTTHotkey_shift, PTTHotkey_ctrl, PTTHotkey_winkey, PTTHotkey_key, b);
end;

function TFrmConfig.GetHumanReadablePlaintextHotkey: string;
var b : boolean;
begin
    result := FrmHotkey.GetHumanReadable(
        PlainTextData.alt,
        PlainTextData.shft,
        PlainTextData.ctrl,
        PlainTextData.win,
        PlainTextData.key,
        b
    );
end;





{
--============================
-- // Load/Save hotkey info //
--============================

}
const ArsClip = 'ArsClip';

procedure TFrmConfig.SaveClipboardBarState;
var ini : TIniFile;
    x,y,width,height : integer;
begin
    ini := TInifile.Create( self.GetINIFileName );

    ini.WriteBool(ArsClip, 'ClipboardBarVisible', frmdummyclipboardbar.isvisible);

    frmDummyClipboardBar.GetSizePos(x,y,width,height);

    ini.writeinteger(ArsClip, 'ClipboardBarX', x);
    ini.writeinteger(ArsClip, 'ClipboardBarY', y);
    ini.writeinteger(ArsClip, 'ClipboardBarWidth', width);
    ini.writeinteger(ArsClip, 'ClipboardBarHeight', height);



    MyFree(ini);
end;

procedure TFrmConfig.LoadClipboardBarState;
var ini : TIniFile;
    x,y,width,height : integer;
begin
    ini := TInifile.Create( self.GetINIFileName );

    if ini.ReadBool(ArsClip, 'ClipboardBarVisible', false) then begin


        //frmDummyClipboardBar.GetSizePos(x,y,width,height);

        frmDummyClipboardBar.SetVisible(true);

        x := ini.readinteger(ArsClip, 'ClipboardBarX', 0);
        y := ini.readinteger(ArsClip, 'ClipboardBarY', 0);
        width := ini.readinteger(ArsClip, 'ClipboardBarWidth', width);
        height := ini.readInteger(ArsClip, 'ClipboardBarHeight', height);

        frmDummyClipboardBar.SetSizePos(x,y,width,height);
    end;

    MyFree(ini);

end;


procedure TFrmConfig.SaveLastPermPath;
var ini: TInifile;

begin
    ini := TInifile.Create( self.GetINIFileName );

    ini.WriteString(ArsClip, 'LastPermanentPath', frmPermanent.GetPermanentPath);

    MyFree(ini);
end;

procedure TFrmConfig.SetRightclickTriggerWarned;
begin
    self.RightclickTriggerWarned := true;
    self.HotkeySave;
end;

function TFrmConfig.GetINIFileName: string;
begin
    Result := UnitMisc.GetAppPath + 'arsclip.ini';
end;

function TFrmConfig.GetOldTrayPopup: boolean;
begin
    result := self.OldTrayPopup;
end;

procedure TFrmConfig.ForceOldTrayPopup;
begin
    self.OldTrayPopup := true;
end;


procedure TFrmConfig.HotkeySave;
var ini: TInifile;
    i : integer;
begin
    ini := TInifile.Create( self.GetINIFileName );

    //
    // Hotkey Panel
    //
    ini.WriteInteger(ArsClip,'Hotkey_Key', Hotkey_Key);
    ini.WriteBool(ArsClip,'Hotkey_Alt', Hotkey_Alt);
    ini.WriteBool(ArsClip,'Hotkey_Shift', Hotkey_Shift);
    ini.WriteBool(ArsClip,'Hotkey_Ctrl', Hotkey_Ctrl);
    ini.WriteBool(ArsClip,'Hotkey_Winkey', Hotkey_Winkey);

    ini.WriteBool(ArsClip,'UseTooltipHotkey', cbUseTooltipHotkey.Checked );
    ini.WriteInteger(ArsClip,'TTHotkey_Key', TTHotkey_Key);
    ini.WriteBool(ArsClip,'TTHotkey_Alt', TTHotkey_Alt);
    ini.WriteBool(ArsClip,'TTHotkey_Shift', TTHotkey_Shift);
    ini.WriteBool(ArsClip,'TTHotkey_Ctrl', TTHotkey_Ctrl);
    ini.WriteBool(ArsClip,'TTHotkey_Winkey', TTHotkey_Winkey);

    ini.WriteInteger(ArsClip,'PTTHotkey_Key', PTTHotkey_Key);
    ini.WriteBool(ArsClip,'PTTHotkey_Alt', PTTHotkey_Alt);
    ini.WriteBool(ArsClip,'PTTHotkey_Shift', PTTHotkey_Shift);
    ini.WriteBool(ArsClip,'PTTHotkey_Ctrl', PTTHotkey_Ctrl);
    ini.WriteBool(ArsClip,'PTTHotkey_Winkey', PTTHotkey_Winkey);


    ini.WriteInteger(ArsClip, 'PlainTextData_key', PlainTextData.key);
    ini.WriteBool(ArsClip, 'PlainTextData_alt', PlainTextData.alt);
    ini.WriteBool(ArsClip, 'PlainTextData_shft', PlainTextData.shft);
    ini.WriteBool(ArsClip, 'PlainTextData_ctrl', PlainTextData.ctrl);
    ini.WriteBool(ArsClip, 'PlainTextData_win', PlainTextData.win);


    //----------
    //'Popup' panel

    ini.WriteBool(Arsclip, 'MoveSelectedToFirst', cbMoveFirst.Checked );
    ini.WriteInteger(ArsClip, UDWidth.Name, udWidth.Position);
    ini.WriteInteger(ArsClip, udMinHeight.Name, udMinHeight.Position);

    if (cbUseKeyboard.Checked) then begin
        ini.WriteString(ArsClip, 'PopupUseKeyboard', 'Y');
    end else begin
        ini.WriteString(ArsClip, 'PopupUseKeyboard', 'N');
    end;
    //ini.WriteInteger(ArsClip, 'CharactersToShow', udCharacters.position);
    //ini.WriteBool(ArsClip, cbDisplayUnicode.Name, cbDisplayUnicode.checked );
    ini.WriteBool(ArsClip, cbDisplayAtMouseCursor.Name, cbDisplayAtMouseCursor.checked);

    ini.WriteBool(Arsclip, 'PopupDoubleclick', cbPopupDoubleclick.checked);
    ini.WriteBool(Arsclip, 'PopupDoubleclickTray', cbPopupDoubleclickTray.checked);
    ini.WriteBool(Arsclip, cbPopupSingleclickTray.Name, cbPopupSingleclickTray.checked);
    ini.WriteBool(Arsclip, cbPopupSingleclick.Name, cbPopupSingleclick.Checked);

    //
    
    ini.WriteInteger(ArsClip, 'CopyClickKey', cboCopyClickKey.ItemIndex  );
    ini.WriteInteger(ArsClip, 'PermanentClickKey', cboPermanentClickKey.ItemIndex );
    ini.WriteInteger(ArsClip, 'MimicClickKey', cboMimicClickKey.ItemIndex );
    ini.WriteBool(ArsClip, rbCtrlClickRun.Name, rbCtrlClickRun.Checked );
    ini.WriteBool(ArsClip, rbCtrlClickMenu.Name, rbCtrlClickMenu.Checked );
    ini.WriteBool(ArsClip, cbRightTriggerEnable.Name, cbRightTriggerEnable.checked);
    //

    ini.WriteInteger(ArsClip, 'RemovedItemsSize', udRemovedSize.Position);

    if (cbDisable.Checked) then begin
        ini.WriteString(ArsClip, 'DisableMonitoring', 'Y');
    end else begin
        ini.WriteString(ArsClip, 'DisableMonitoring', 'N');
    end;
    ini.WriteBool(ArsClip, cbShowAllAsSubmenus.Name, cbShowAllAsSubmenus.checked);
    ini.WriteBool(ArsClip, 'DisableWhenScrollLock', cbDisableWhenScrollLock.checked);
    ini.WriteBool(ArsClip, 'CopyIcons', cbCopyIcons.checked);
    ini.WriteBool(ArsClip, 'DisableSystemTrayIconNotification', cbDisableSystemTrayIconNotification.Checked   );
    ini.WriteBool(ArsClip, cbDisableChainNotification.name, cbDisableChainNotification.checked );
    ini.WriteBool(ArsClip, cbEnableExtendedChainChecking.Name, cbEnableExtendedChainChecking.Checked);
    ini.WriteBool(ArsClip, cbDisableWatcher.name, cbDisableWatcher.checked );
    ini.WriteBool(ArsClip, cbShowEditInstead.Name, cbShowEditInstead.checked);
    ini.WriteBool(ArsClip, cbDontCopySelectedForAll.name, cbDontCopySelectedForAll.Checked);

    ini.WriteInteger(ArsClip, udRecentlyRemoved.Name, udRecentlyRemoved.Position);

    ini.WriteString(ArsClip, 'LastPermanentPath', frmPermanent.GetPermanentPath);

    ini.WriteBool(ArsClip,'ShowPermanentItemGroups', cbShowPermanentItemGroups.checked );
    ini.WriteBool(ArsClip, 'ShowPermanentItemSubmenu', cbPermanentItemsSubmenu.Checked );
    //ini.WriteBool(ArsClip, 'ShowFormMode', cbShowFormMode.Checked);
    if (rbTyping.Checked) then begin
        ini.WriteString(ArsClip,'PasteMethod', 'MimicTyping');
    end else if (rbPaste.checked) then begin
        ini.WriteString(ArsClip, 'PasteMethod', 'CTRL+V');
    end else if (rbPasteSI.Checked) then begin
        ini.WriteString(ArsClip, 'PasteMethod', 'SHIFT+INSERT');
    end else begin
        ini.WriteString(ArsClip, 'PasteMethod', 'ClipboardOnly');
    end;
    ini.WriteBool(ArsClip, cbPasteComplex.Name, cbPasteComplex.Checked);


    // clipboard
    ini.WriteBool(ArsClip, 'RememberHistory', cbRemember.checked);
    //ini.WriteBool(ArsClip, 'ShowEditHistory', cbShowEditHistory.Checked);
    //ini.WriteBool(ArsClip, cbShowTypes.Name, cbShowTypes.checked);
    ini.WriteBool(ArsClip, cbAutofixURLs.Name, cbAutofixURLs.Checked);
    ini.WriteBool(ArsClip, cbShowAllItems.Name, cbShowAllItems.checked);

    // text items
    ini.WriteInteger(ArsClip, 'QueueSize', udQueueSize.position);
    ini.WriteBool(ArsClip, 'MonitorFilenames', cbMonitorFilenames.checked);
    ini.WriteBool(ArsClip, 'MoveDuplicate', cbMoveDuplicate.checked );
    ini.writeBool(ArsClip, cbRemoveFormat.name, cbRemoveFormat.checked );
    ini.WriteBool(ArsClip, cbCaseSensitive.name, cbCaseSensitive.checked);

    for i := 0 to lvFormats.items.Count - 1 do begin
        ini.WriteString(ArsClip, lvFormats.name  + IntToStr(i) , lvFormats.Items[i].Caption);
        ini.WriteBool(ArsClip, lvFormats.name  + IntToStr(i) + 'checked' , lvFormats.Items[i].checked);
    end;

    //self.CopySelected := false;
    for i := 0 to lvOrder.items.Count - 1 do begin
        if TMenuOrderType(lvOrder.Items[i].data) = MOT_SELECTED then
            self.CopySelected := lvOrder.Items[i].Checked;
        ini.WriteInteger(ArsClip, LVORDER_ID +  lvOrder.name  + IntToStr(i) + 'data' , Integer(lvOrder.Items[i].data));
        ini.WriteString(ArsClip, LVORDER_ID + lvOrder.name  + IntToStr(i) + 'sub' , lvOrder.Items[i].SubItems[0]);
        ini.WriteBool(ArsClip, LVORDER_ID + lvOrder.name  + IntToStr(i) + 'checked', lvOrder.Items[i].Checked);
    end;

    //-------------------
    // Non-text items
    //-------------------
    ini.WriteBool(ArsClip,'EnableOtherItems', cbOtherItems.Checked);
    ini.WriteInteger(ArsClip, 'OtherSize', udOtherSize.Position);
    ini.WriteInteger(ArsClip,'OtherSizeLimitKB', StrToInt(txtOtherSizeLimitKB.text));

    if (rbOtherPaste.Checked) then begin
        ini.WriteString(ArsClip, 'OtherPasteMethod', 'CTRL+V' );
    end else begin
        ini.WriteString(ArsClip, 'OtherPasteMethod',  'ClipboardOnly');
    end;

    ini.WriteBool(ArsClip, cbSeparateNontextList.Name, cbSeparateNontextList.Checked);

    //-------------
    // Tooltip
    //-------------
    ini.WriteBool(ArsClip,'FullHeader', cbFullHeader.Checked);
    ini.WriteBool(ArsClip,'CopyVisibleItem', cbCopyVisibleItem.Checked);

        // Tooltip Hint
    ini.WriteInteger(ArsClip, UDToolHeight.Name, UDToolHeight.Position);
    ini.WriteInteger(ArsClip, UDToolWidth.Name, UDToolWidth.Position);



    Ini.WriteBool(ArsClip,'EnableSound', cbEnableSound.Checked);
    //lblKeyname.Caption := self.GetHumanReadableHotkey;


    //'''

    //-----------
    // no visible control
    ini.WriteInteger(ArsClip,'RightClickDelay', self.RightClickDelay);
    ini.WriteBool(ArsClip, 'RightclickTriggerWarned', self.RightclickTriggerWarned);
    ini.WriteInteger(ArsClip,'PasteDelay', self.PasteDelay);




    MyFree(ini);

end;



procedure TFrmConfig.lvOrderInfoTip(Sender: TObject; Item: TListItem;
  var InfoTip: string);
begin
    InfoTip := MenuOrderText(TMenuOrderType(item.Data), true);
end;

function TFrmConfig.MenuOrderText(m: TMenuOrderType; description:boolean): string;
begin
    if description then begin
        case m of
            MOT_MENU:result := 'Text Clip history';
            MOT_OTHER:result := 'Non-Text Clip history';
            MOT_CANCEL:result := 'Closes the popup';
            MOT_LAST:result := 'Last clicked text item on popup';
            MOT_CURRENT:result := 'Current clipboard''s contents';
            MOT_REMOVED:result := 'Submenu of Clips recently removed from the list';
            MOT_PROGRAM: result := 'Custom options for the current target program';
            MOT_SYSTEM:result := 'ArsClip''s System Options menu';
            MOT_MISC:   result := 'Misc items menu';
            MOT_PERMANENT:result := 'Clips in the current Permanent Group';
            MOT_SWITCH:result := 'Switches to another Permanent Group';
            MOT_FULL: result := 'Switches to Full/Configured Mode';
            MOT_ALLITEMS: result := 'A submenu of All Permanent items';
            MOT_SELECTED: result := 'Edit the selected text in the current window';
            MOT_CLICKED: result := 'Submenu of Clips recently clicked on';
            MOT_SEARCH: result := 'Search all text Clips ';
            MOT_BREAK: result := 'Creates a new Column';
        end;
    end else begin
        case m of
            MOT_MENU:result := 'Text';
            MOT_OTHER:result := 'Non-Text';
            MOT_CANCEL:result := 'Cancel';
            MOT_CURRENT:result := 'Current:';
            MOT_LAST:result := 'Last:';
            MOT_REMOVED:result := 'Recently Removed';
            MOT_PROGRAM: result := 'Program Options';
            MOT_SYSTEM:result := 'System';
            MOT_MISC:   result := 'Misc';
            MOT_PERMANENT:result := 'Current Permanent Clips';
            MOT_SWITCH:result := 'Permanent Groups Switch';
            MOT_FULL: result := 'Full/Configured';
            MOT_ALLITEMS: result := 'All Items ...';
            MOT_SELECTED : result := 'Edit Selected:';
            MOT_CLICKED: result := 'Recently Clicked';
            MOT_SEARCH: result := 'Search';
            MOT_BREAK: result := '(Column Break)';
        end;
    end;
end;

procedure TFrmConfig.Panel8Click(Sender: TObject);
begin
   frmMainPopup.Visible := frmMainPopup.Visible xor true;
end;

procedure TFrmConfig.HotkeyLoad;
var ini: TInifile;
    s : string;
    data : integer;
    i, j,k,m,n : integer;
    c : cardinal;
    fs : TFontStyles;

    showorderfound : array[TMenuOrderType] of boolean;
    li : TListItem;


    procedure CopyLI(dest, src : TListItem);
    begin
        dest.caption := src.caption;
        dest.SubItems.Clear;
        dest.SubItems.AddStrings(src.SubItems);
        dest.checked := src.Checked;
        dest.Data := src.data;
    end;
begin
    //
    // read last assigned hotkey
    // CTRL+SHIFT+Z is default
    //
    // fake the user selecting the Modifier and the Normal Key

    ini := TInifile.Create( self.GetINIFileName );

    FrmDummyUnicodePopup.Font.Name := ini.ReadString('Font','Name', 'Arial');
    FrmDummyUnicodePopup.Font.Charset := ini.ReadInteger('Font','CharSet', FrmDummyUnicodePopup.Font.Charset);
    FrmDummyUnicodePopup.Font.Color := ini.ReadInteger('Font','Color', FrmDummyUnicodePopup.Font.Color);
    FrmDummyUnicodePopup.Font.Size := ini.ReadInteger('Font','Size', FrmDummyUnicodePopup.Font.Size);

    c := ini.ReadInteger('Font','Style',0);
    move(c, fs, 4);
    FrmDummyUnicodePopup.Font.Style := fs;

    FontDialog.Font := FrmDummyUnicodePopup.Font;

    self.PreCaptureDelayMS := ini.ReadInteger(ArsClip,'PreCaptureDelay', 50);
    ini.WriteInteger(ArsClip,'PreCaptureDelay', self.PreCaptureDelayMS);
    self.RightClickDelay := ini.ReadInteger(ArsClip,'RightClickDelay', 600);
    ini.WriteInteger(ArsClip,'RightClickDelay', self.RightClickDelay);
    self.OldTrayPopup := ini.ReadBool(ArsClip, 'OldTrayPopup', false);
    ini.WriteBool(ArsClip,'OldTrayPopup', self.OldTrayPopup);


    //----------
    // HotKey
    //----------
    Hotkey_Key := ini.ReadInteger(ArsClip,'Hotkey_Key', Ord('Z'));
    Hotkey_Alt := ini.ReadBool(ArsClip,'Hotkey_Alt', false);
    Hotkey_Shift := ini.ReadBool(ArsClip,'Hotkey_Shift', true);
    Hotkey_Ctrl := ini.ReadBool(ArsClip,'Hotkey_Ctrl', true);
    Hotkey_Winkey := ini.ReadBool(ArsClip,'Hotkey_Winkey', false);

    cbUseTooltipHotkey.Checked := ini.ReadBool(ArsClip,'UseTooltipHotkey',false);
    TTHotkey_Key := ini.ReadInteger(ArsClip,'TTHotkey_Key', Ord('X'));
    TTHotkey_Alt := ini.ReadBool(ArsClip,'TTHotkey_Alt', false);
    TTHotkey_Shift := ini.ReadBool(ArsClip,'TTHotkey_Shift', true);
    TTHotkey_Ctrl := ini.ReadBool(ArsClip,'TTHotkey_Ctrl', true);
    TTHotkey_Winkey := ini.ReadBool(ArsClip,'TTHotkey_Winkey', false);

    PTTHotkey_Key := ini.ReadInteger(ArsClip,'PTTHotkey_Key', Ord('C'));
    PTTHotkey_Alt := ini.ReadBool(ArsClip,'PTTHotkey_Alt', false);
    PTTHotkey_Shift := ini.ReadBool(ArsClip,'PTTHotkey_Shift', true);
    PTTHotkey_Ctrl := ini.ReadBool(ArsClip,'PTTHotkey_Ctrl', true);
    PTTHotkey_Winkey := ini.ReadBool(ArsClip,'PTTHotkey_Winkey', false);

    PlainTextData.key := ini.ReadInteger(ArsClip, 'PlainTextData_key', ord('V'));
    PlainTextData.alt := ini.ReadBool(ArsClip, 'PlainTextData_alt', false);
    PlainTextData.shft := ini.ReadBool(ArsClip, 'PlainTextData_shft', false);
    PlainTextData.ctrl := ini.ReadBool(ArsClip, 'PlainTextData_ctrl', false);
    PlainTextData.win := ini.ReadBool(ArsClip, 'PlainTextData_win', true);


    //----------------
    // 'Popup' panel
    //----------------
    cbMoveFirst.Checked := ini.ReadBool(ArsClip, 'MoveSelectedToFirst', false);
    cbUseKeyboard.Checked := (ini.ReadString(ArsClip,'PopupUseKeyboard', 'Y') = 'Y');
    cbPopupDoubleclick.checked := ini.ReadBool(Arsclip, 'PopupDoubleclick', false);
    cbPopupDoubleclickTray.checked := ini.ReadBool(Arsclip, 'PopupDoubleclickTray', false);
    //udCharacters.position := ini.ReadInteger(ArsClip, 'CharactersToShow', 30);
    //frmMainPopup.SetVisibleCharacterCount(udCharacters.position);
    cboCopyClickKey.ItemIndex :=     ini.ReadInteger(ArsClip, 'CopyClickKey', 0 );
    cboPermanentClickKey.ItemIndex :=    ini.ReadInteger(ArsClip, 'PermanentClickKey', 1);
    cboMimicClickKey.ItemIndex := ini.ReadInteger(ArsClip, 'MimicClickKey', 2 );
    rbCtrlClickRun.Checked := false;
    rbCtrlClickMenu.Checked := false;
    rbCtrlClickRun.Checked := ini.ReadBool(ArsClip, rbCtrlClickRun.Name, false);
    rbCtrlClickMenu.Checked := ini.ReadBool(ArsClip, rbCtrlClickMenu.name, true );
    //cbDisplayUnicode.checked := ini.ReadBool(ArsClip, cbDisplayUnicode.Name,  false);
    //cbDisplayUnicode.checked := true;
    cbDisplayAtMouseCursor.checked :=ini.ReadBool(ArsClip, cbDisplayAtMouseCursor.Name, false);

    cbPopupSingleclickTray.checked := ini.ReadBool(Arsclip, cbPopupSingleclickTray.Name, false);
    cbPopupSingleclick.Checked := ini.ReadBool(Arsclip, cbPopupSingleclick.Name, false);
    udWidth.Position := ini.ReadInteger(ArsClip, UDWidth.Name, 320);
    udMinHeight.Position := ini.ReadInteger(ArsClip, udMinHeight.Name, 16);
    cbRightTriggerEnable.Checked := ini.readbool(ArsClip, cbRightTriggerEnable.Name, true);


    self.cboCopyClickKeyClick(self);
    self.cboPermanentClickKeyClick(self);
    self.cboMimicClickKeyClick(self);
    // setting the ItemIndex doesn't auto set of any event

    //-------------------
    // Show Options
    //-------------------

    //cbShowEditHistory.checked := ini.ReadBool(ArsClip,'ShowEditHistory', false);
    udRecentlyRemoved.Position := ini.ReadInteger(ArsClip, udRecentlyRemoved.Name, 5);
    txtRecentlyRemoved.Text := IntToStr(udRecentlyRemoved.Position);
    cbShowPermanentItemGroups.checked := ini.ReadBool(ArsClip,'ShowPermanentItemGroups', true );

    cbPermanentItemsSubmenu.checked := ini.Readbool(ArsClip,'ShowPermanentItemSubmenu', false);
    //cbShowFormMode.Checked := ini.ReadBool(ArsClip, 'ShowFormMode', false);
    //cbShowTypes.checked  := ini.ReadBool(ArsClip, cbShowTypes.Name, true);
    //cbShowTypes.checked := false;
    cbShowAllItems.checked := ini.ReadBool(ArsClip, cbShowAllItems.Name, true);
    cbShowAllAsSubmenus.checked := ini.ReadBool(ArsClip, cbShowAllAsSubmenus.Name, false);
    cbShowEditInstead.checked := ini.ReadBool(ArsClip, cbShowEditInstead.Name, false);

    //-------------------
    // Pasting
    //-------------------
    rbTyping.Checked := ini.ReadString(ArsClip, 'PasteMethod', 'CTRL+V') = 'MimicTyping';
    rbPaste.Checked := ini.ReadString(ArsClip, 'PasteMethod', 'CTRL+V') = 'CTRL+V';
    rbClipboardOnly.checked := ini.ReadString(ArsClip, 'PasteMethod', 'CTRL+V') = 'ClipboardOnly';
    rbPasteSI.Checked := ini.ReadString(ArsClip, 'PasteMethod', 'CTRL+V') = 'SHIFT+INSERT';
    rbOtherClipboardOnly.Checked := ini.ReadString(ArsClip, 'OtherPasteMethod',  'ClipboardOnly') = 'ClipboardOnly';
    rbOtherPaste.Checked := ini.ReadString(ArsClip, 'OtherPasteMethod',  'ClipboardOnly') = 'CTRL+V';
    cbPasteComplex.Checked := ini.ReadBool(ArsClip, cbPasteComplex.Name, false);

    //-------------------
    // Clipboard
    //-------------------
    cbCopyIcons.Checked := ini.ReadBool(ArsClip,'CopyIcons', true);
    cbDisable.Checked := (ini.ReadString(ArsClip,'DisableMonitoring','N') = 'Y');
    cbDisableWhenScrollLock.Checked := ini.ReadBool(ArsClip, 'DisableWhenScrollLock', false);
    cbDisableSystemTrayIconNotification.Checked := ini.ReadBool(ArsClip,'DisableSystemTrayIconNotification', false);
    cbDisableChainNotification.checked := ini.ReadBool(ArsClip, cbDisableChainNotification.name,  false);
    cbEnableExtendedChainChecking.Checked := ini.ReadBool(ArsClip, cbEnableExtendedChainChecking.Name, false);
    cbAutofixURLs.Checked := ini.ReadBool(ArsClip, cbAutofixURLs.Name, false);
    cbDisableWatcher.checked := ini.ReadBool(ArsClip, cbDisableWatcher.name,  false);
    cbDontCopySelectedForAll.Checked := ini.ReadBool(ArsClip, cbDontCopySelectedForAll.name, True);


    //------------------------
    // Clipboard Non-text
    //------------------------

    cbOtherItems.Checked := ini.ReadBool(ArsClip,'EnableOtherItems', false);
    udOtherSize.Position := ini.ReadInteger(ArsClip, 'OtherSize', 5);
    txtOtherSizeLimitKB.text := IntToStr(ini.ReadInteger(ArsClip,'OtherSizeLimitKB', 500));
    cbSeparateNontextList.Checked := ini.ReadBool(ArsClip,cbSeparateNontextList.Name, false);


    // Ect - util stuff
    // HuH? The "Other" config options above seem not to work
    txtOtherSizeLimitKB.OnChange(self);
    OtherQueue.SetQueueSize(udOtherSize.position);

    cbEnableSound.Checked := Ini.ReadBool(ArsClip,'EnableSound', False);
    PlaySound_Init;

    //-----------------------
    // Clipboard Text
    //-----------------------
    udqueuesize.Position  := ini.ReadInteger(ArsClip, 'QueueSize', 15);
    udRemovedSize.Position := ini.ReadInteger(ArsClip, 'RemovedItemsSize', 50);
    ClipQueue.SetQueueSize(udQueueSize.position);
    RemovedQueue.SetQueueSize(udRemovedSize.position);
    cbMonitorFilenames.Checked :=  ini.ReadBool(ArsClip, 'MonitorFilenames', false);
    cbRemember.Checked := ini.ReadBool(ArsClip, 'RememberHistory', true);
    cbMoveDuplicate.checked := ini.ReadBool(ArsClip, 'MoveDuplicate', true);
    cbRemoveFormat.checked := ini.ReadBool(ArsClip, cbremoveformat.name, false);
    cbCaseSensitive.checked := ini.ReadBool(ArsClip, cbCaseSensitive.name, false);

    s := '';
    i := 0;
    repeat
        s := ini.ReadString(ArsClip, lvFormats.name  + IntToStr(i) ,'');
        if s <> '' then begin
            lvFormats.Items[i].Caption := s;
            lvFormats.Items[i].checked := ini.ReadBool(ArsClip, lvFormats.name  + IntToStr(i) + 'checked', true);
        end;
        inc(i);
    until s = '';



    //------------------------
    //  Show Order
    //------------------------


    s := '';
    i := 0;
    //self.CopySelected := false;

    // First, generate a list of all found items with their default states
    for i := ord(low(tmenuordertype)) to ord(high(tmenuordertype)) do begin
        showorderfound[tmenuordertype(i)] := false;
    end;
    for i := ord(low(tmenuordertype)) to ord(high(tmenuordertype)) do begin


        data := ini.ReadInteger(ArsClip, LVORDER_ID +  lvOrder.name  + IntToStr(i)+'data' ,-1);
        if (data <> -1) then begin
            li := lvorder.FindCaption(0,self.MenuOrderText(TMenuOrderType(data),false),false,true,false);

            if li <> nil then begin
                showorderfound[tmenuordertype(data)] := true;
                defaultmenuorder[tmenuordertype(data)] := i;
                li.subitems[0] := ini.ReadString(ArsClip, LVORDER_ID + lvOrder.name  + IntToStr(i) + 'sub' , 'no');
                li.Checked := ini.ReadBool(ArsClip, LVORDER_ID +  lvOrder.name  + IntToStr(i) + 'checked', true);

                if TMenuOrderType(data) = MOT_SELECTED  then
                    self.CopySelected := lvOrder.Items[i].Checked;
            end;
        end;
    end;
    {
    // update by logically insert the new items
    for i := ord(low(tmenuordertype)) to ord(high(tmenuordertype)) do begin
        if not showorderfound[tmenuordertype(i)] then begin
            k := defaultmenuorder[TMenuOrderType(i)];
            for j := ord(low(tmenuordertype)) to ord(high(tmenuordertype)) do begin
                if j <> i then
                    if defaultmenuorder[TMenuOrderType(i)] >= k then begin
                        inc(defaultmenuorder[TMenuOrderType(i)]);
                    end;
            end;
        end;
    end;
    }

    //
    // move all items to default positions
    // (basic bubble sort)
    for i := ord(low(tmenuordertype)) to ord(high(tmenuordertype)) {- 1} do begin
        li := lvorder.FindCaption(0,self.MenuOrderText(TMenuOrderType(i),false),false,true,false);
        if li <> nil then begin
            k := DefaultMenuOrder[TMenuOrderType(i)];
            j := li.Index;
            if (j>k) then begin
                for m := j downto k + 1 do begin
                    // swap m and (m-1)
                    li := lvOrder.Items.Add;
                    CopyLI(li, lvOrder.items[m]);
                    CopyLI(lvOrder.items[m], lvOrder.items[m-1]);
                    CopyLI(lvOrder.items[m-1], li);
                    lvOrder.Items.Delete(li.Index);
                end;
            end else if (j<k) then begin
                for m := j to k - 1 do begin
                    // swap m and (m-1)
                    li := lvOrder.Items.Add;
                    CopyLI(li, lvOrder.items[m]);
                    CopyLI(lvOrder.items[m], lvOrder.items[m+1]);
                    CopyLI(lvOrder.items[m+1], li);
                    lvOrder.Items.Delete(li.Index);
                end;

            end;
        end;
    end;


    // Something removes all previous checks
    // find each item in the list and then read the value of "Checked"
    // and default the TRUE when not found (when it's a new item)
    {for I := ord(low(tmenuordertype)) to ord(high(tmenuordertype))  do begin
        li := lvorder.FindCaption(0,self.MenuOrderText(TMenuOrderType(i),false),false,true,false);
        if li <> nil then begin
            data := ini.ReadInteger(ArsClip, LVORDER_ID +  lvOrder.name  + IntToStr(i)+'data' ,-1);
            if (data <> -1) then begin
                li.Checked := ini.ReadBool(ArsClip, LVORDER_ID +  lvOrder.name  + IntToStr(i) + 'checked', true);
            end else begin
                li.checked := true;
            end;
        end;
    end;
    }

    cbUseKeyboard.OnClick(self);
    cbDisable.OnClick(self);

    frmPermanent.SetPermanentPath(ini.ReadString(ArsClip, 'LastPermanentPath', UnitFrmPermanentNew.DEFAULT_FOLDER));

    //------------------------
    //  Tooltip
    //------------------------
    cbFullHeader.Checked := ini.ReadBool(ArsClip,'FullHeader', true);
    cbCopyVisibleItem.Checked := ini.ReadBool(ArsClip,'CopyVisibleItem', false);


    //------------------------
    //  Tooltip Hint
    //------------------------

    UDToolHeight.Position := ini.ReadInteger(ArsClip, UDToolHeight.Name, 200);
    UDToolWidth.Position := ini.ReadInteger(ArsClip, UDToolWidth.Name, 320);

    //
    // these are here because because there is no "onchange"
    // triggered when the control's state is changed
    //
    if (rbOtherPaste.Checked) then begin
        frmMainPopup.SetOtherPasteMethodPasting;
    end else begin
        FrmMainPopup.SetOtherPasteMethodClipboardOnly;
    end;

    if rbTyping.checked then
        Paste.SetMimicTyping;

    if rbClipboardOnly.checked then
        Paste.SetClipboardOnly;

    if rbPaste.Checked then
        Paste.SetUsePaste;
    if rbPasteSI.Checked then
        Paste.SetUsePasteSI;

    lblKeyname.Caption := self.GetHumanReadableHotkey;
    lblTooltipKeyname.Caption := self.GetHumanReadableTTHotkey;
    lblPreviousTooltipKeyname.Caption := self.GetHumanReadablePTTHotkey;
    lblPlaintext.Caption := self.getHumanReadablePlaintextHotkey;



    //
    // Etc - non controls
    //

    self.RightclickTriggerWarned := ini.ReadBool(ArsClip, 'RightclickTriggerWarned', false);
    self.PasteDelay := ini.ReadInteger(ArsClip,'PasteDelay', 10);
    self.ClipboardBarVisible := ini.ReadBool(arsclip, 'ClipboardBarVisible', false);

    MyFree(ini);
end;


{
--========================
-- // Release/Assign    //
--========================

Returns true if successful.

}

{function TFrmConfig.HotKeyRelease(): boolean;
begin
    result := UnRegisterHotKey(frmMainPopup.handle, HotKeyID)
end;

function TFrmConfig.HotKeyAssign(
    Ctrl: boolean; Alt: boolean; Shift: boolean; Winkey : boolean;
    Keystroke: word; FunctionKey : boolean): boolean;
var modifier: word;
begin
    modifier := 0;
    if ctrl then modifier := modifier or MOD_CONTROL;
    if alt then  modifier := modifier or MOD_ALT;
    if shift then modifier := modifier or MOD_SHIFT;
    if winkey then modifier := modifier or MOD_WIN;
    result := false;
    if (HotKeyID = 0) then begin
        exit;
    end;


    // this alteration allows for using , . ` in hotkeys
    //if (not functionkey) then begin
    //    keystroke := VkKeyScan(char(Keystroke)) and $ff;
    //end;
    if not ( RegisterHotKey(frmMainPopup.handle, HotKeyID, modifier, Keystroke)) then begin
        exit;
    end;

    result := true;
end;
}
{
--========================
-- // Control Events    //
--========================

}
{function TFrmConfig.SetHotKey : boolean;
begin
    result := false;

    //
    // if the user tries to assign to a hotkey that is already in use,
    // the hotkeyrelease failing is OK
    //
    self.HotKeyRelease();


    if not (self.HotKeyAssign(Hotkey_Ctrl, Hotkey_Alt, Hotkey_Shift, Hotkey_Winkey,
        Hotkey_key, false)) then begin
        ShowMessage('ERROR: Couldn''t assign hotkey. It may already be assigned by another program.');
    end else begin
        result := true;
    end;
end;
}


procedure TFrmConfig.cbKeyChange(Sender: TObject);
begin
end;


//============================
// Clipboard Options
//============================

procedure TFrmConfig.cbUseKeyboardClick(Sender: TObject);
begin
    frmMainPopup.setpopupusekeyboard(cbUseKeyboard.Checked);
end;

function TFrmConfig.ClipboardBarSetVisible: boolean;
begin
    result := self.ClipboardBarVisible;
end;

function TFrmConfig.CopySelectedForPopup: boolean;
begin
    result := self.CopySelected;
end;

{
Make the user use the up/down to change the queue size
}
procedure TFrmConfig.txtQueueSizeKeyPress(Sender: TObject; var Key: Char);
begin
    // ignore keystrokes
    key := chr(0);
end;

procedure TFrmConfig.txtOldHistorySizeKeyPress(Sender: TObject;
  var Key: Char);
begin
    // ignore keystrokes
    Key := Chr(0);
end;

procedure TFrmConfig.txtOtherSizeKeyPress(Sender: TObject; var Key: Char);
begin
    key := chr(0);
end;


procedure TFrmConfig.cbOtherItemsClick(Sender: TObject);
begin
    udOtherSize.Enabled := cbOtherItems.Checked;
    txtOtherSizeLimitKB.Enabled := cbOtherItems.Checked;
    frmClipboardManager.SetOtherItemsMonitoring(cbOtherItems.Checked);

end;

procedure TFrmConfig.txtOtherSizeLimitKBChange(Sender: TObject);
begin
    OtherQueue.SetClipSizeLimit( StrToInt(txtOtherSizeLimitKB.text) * 1024);
end;

procedure TFrmConfig.udOtherSizeClick(Sender: TObject; Button: TUDBtnType);
begin
    OtherQueue.SetQueueSize(udOtherSize.position);
end;


procedure TFrmConfig.udQueueSizeClick(Sender: TObject; Button: TUDBtnType);
begin
    ClipQueue.SetQueueSize(udQueueSize.position);
end;
procedure TFrmConfig.udRemovedSizeClick(Sender: TObject; Button: TUDBtnType);
begin
    RemovedQueue.SetQueueSize(udRemovedSize.position);
end;


procedure TFrmConfig.cbDisableClick(Sender: TObject);
begin
    frmClipboardManager.SetDisableMonitoring(cbdisable.Checked);
end;

procedure TFrmConfig.cbMonitorFilenamesClick(Sender: TObject);
begin
    frmClipboardManager.SetFilenameMonitoring(cbMonitorFilenames.checked);
end;
procedure TFrmConfig.cbRememberClick(Sender: TObject);
begin
    frmMainPopup.SetRememberHistory(cbRemember.checked);
    // this loads only the first time
    if (cbRemember.Checked) then begin
        frmClipboardManager.LoadHistory;
        //frmRemoved.LoadHistory;
    end;
end;

procedure TFrmConfig.cbRightTriggerEnableClick(Sender: TObject);
begin
    if cbRightTriggerEnable.checked then begin
        frmmainpopup.tim.Enabled := true;
    end else begin
        frmmainpopup.tim.Enabled := false;
    end;
end;

procedure TFrmConfig.cbCopyIconsClick(Sender: TObject);
begin
    frmClipboardManager.SetCopyIcon(cbCopyIcons.Checked);
end;

procedure TFrmConfig.cbMoveDuplicateClick(Sender: TObject);
begin
    ClipQueue.SetMoveDuplicateTop(cbMoveDuplicate.checked);
end;




procedure TFrmConfig.cbShowEditHistoryClick(Sender: TObject);
begin
    //FrmMainPopup.SetShowEditHistory(cbShowEditHistory.checked);
end;

procedure TFrmConfig.btnEditPermanentItemsClick(Sender: TObject);
begin
    frmPermanent.ShowModal;
end;

procedure TFrmConfig.cbPasteAllClick(Sender: TObject);
begin

end;


//============================
// Pasting Options
//============================
procedure TFrmConfig.rbTypingClick(Sender: TObject);
begin
    Paste.SetMimicTyping;
end;
procedure TFrmConfig.rbPasteClick(Sender: TObject);
begin
    Paste.SetUsePaste;
end;
procedure TFrmConfig.rbPasteSIClick(Sender: TObject);
begin
    Paste.SetUsePasteSI;
end;
procedure TFrmConfig.rbClipboardOnlyClick(Sender: TObject);
begin
    Paste.SetClipboardOnly;
end;






procedure TFrmConfig.cbMoveFirstClick(Sender: TObject);
begin
    frmMainPopup.SetMoveSelectedItemToTop(cbmovefirst.checked);
end;
procedure TFrmConfig.udCharactersClick(Sender: TObject;
  Button: TUDBtnType);
begin

end;



//
// close/save/cancel
// TreeView clicks
//
procedure TFrmConfig.btnSaveClick(Sender: TObject);
begin
    self.HotkeySave;
    
    try
        if HotKeyPopup = nil then begin
            try
                HotKeyPopup := TACHotKey.Create(
                    FrmMainPopup.Handle, 'ArsClip.HotkeyPopup',
                    Hotkey_Ctrl, Hotkey_Alt,
                    Hotkey_Shift, Hotkey_Winkey, Hotkey_key);
            except
                // if it wasn't already created, this save is likely
                // generating the same error as when the program started
                // -- ignore here
            end;

        end else begin
            HotKeyPopup.SetHotKey(Hotkey_Ctrl, Hotkey_Alt,
                Hotkey_Shift, Hotkey_Winkey, Hotkey_key);
        end;

        if PlainTextHotKey = nil then begin
            try
                PlainTextHotKey := TACHotKey.Create(
                    FrmMainPopup.Handle, 'ArsClip.PlainTextHotKey',
                    PlainTextData.Ctrl, PlainTextData.Alt,
                    PlainTextData.Shft, PlainTextData.Win, PlainTextData.key);
            except

            end;

        end else begin
            PlainTextHotKey.SetHotKey(PlainTextData.Ctrl, PlainTextData.Alt,
                PlainTextData.Shft, PlainTextData.Win, PlainTextData.key);
        end;

        if (cbUseTooltipHotkey.checked) then begin
            if (TTHotKeyPopup <> nil) then begin
                TTHotKeyPopup.SetHotKey(TTHotkey_Ctrl, TTHotkey_Alt,
                    TTHotkey_Shift, TTHotkey_Winkey, TTHotkey_key);
                PTTHotKeyPopup.SetHotKey(PTTHotkey_Ctrl, PTTHotkey_Alt,
                    PTTHotkey_Shift, PTTHotkey_Winkey, PTTHotkey_key)
            end else begin
                TTHotKeyPopup := TACHotKey.Create(FrmMainPopup.handle, 'ArsClip.exe.MyTTHotKey',
                    TTHotkey_Ctrl, TTHotkey_Alt, TTHotkey_Shift,
                    TTHotkey_Winkey, TTHotkey_Key
                );
                PTTHotKeyPopup := TACHotKey.Create(FrmMainPopup.handle, 'ArsClip.exe.MyPTTHotKey',
                    PTTHotkey_Ctrl, PTTHotkey_Alt, PTTHotkey_Shift,
                    PTTHotkey_Winkey, PTTHotkey_Key
                );
            end;
        end else begin
            MyFree(TTHotKeyPopup);
            MyFree(PTTHotKeyPopup);
        end;
    except
        //EXIT;
    end;
    {if (self.SetHotKey) then begin}
        self.close;
    {end;}
end;

procedure TFrmConfig.Button1Click(Sender: TObject);
var li : TListITem;
begin
    li := lvOrder.Selected;
    if li <> nil then begin
        if li.SubItems[0] = 'Yes' then
         li.SubItems[0] := 'no'
        else
         li.SubItems[0] := 'Yes';

    end;
end;

procedure TFrmConfig.btnCancelClick(Sender: TObject);
begin
    self.Close;
end;

procedure TFrmConfig.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    self.HotkeyLoad;
end;






procedure TFrmConfig.tvOptionsClick(Sender: TObject);
begin
    //self.ShowNewPanel;
    pcPanels.ActivePageIndex := (tvOptions.Selected.AbsoluteIndex);
end;

procedure TFrmConfig.tvOptionsCollapsing(Sender: TObject; Node: TTreeNode;
  var AllowCollapse: Boolean);
begin
    AllowCollapse := false;
end;

procedure TFrmConfig.bEditPopupHotkeyClick(Sender: TObject);
var w : word;
    s : string;
    ha, hs, hc, hw : boolean;
begin
    if FrmHotkey.GetHotkey( ha, hs ,hc , hw, w, s) then begin
       Hotkey_Alt    := ha;
       Hotkey_Shift  := hs;
       Hotkey_Ctrl   := hc;
       Hotkey_Winkey := hw;
       Hotkey_Key    := w;
       lblKeyname.caption := s;
    end;
end;

procedure TFrmConfig.btnEditPlaintextHotkeyClick(Sender: TObject);
var w : word;
    s : string;
    ha, hs, hc, hw : boolean;
begin
    if FrmHotkey.GetHotkey( ha, hs ,hc , hw, w, s) then begin
       PlainTextData.Alt    := ha;
       PlainTextData.Shft   := hs;
       PlainTextData.Ctrl   := hc;
       PlainTextData.Win    := hw;
       PlainTextData.Key    := w;
       lblPlaintext.caption := s;
    end;
end;

procedure TFrmConfig.bEditToolTipHotkeyClick(Sender: TObject);
var w : word;
    s : string;
    ha, hs, hc, hw : boolean;
begin
    if FrmHotkey.GetHotkey( ha, hs ,hc , hw, w, s) then begin
       TTHotkey_Alt    := ha;
       TTHotkey_Shift  := hs;
       TTHotkey_Ctrl   := hc;
       TTHotkey_Winkey := hw;
       TTHotkey_Key    := w;
       lblToolTipKeyname.caption := s;
    end;
end;

procedure TFrmConfig.bEditPreviousToolTipHotkeyClick(Sender: TObject);
var w : word;
    s : string;
    ha, hs, hc, hw : boolean;
begin
    if FrmHotkey.GetHotkey( ha, hs ,hc , hw, w, s) then begin
       PTTHotkey_Alt    := ha;
       PTTHotkey_Shift  := hs;
       PTTHotkey_Ctrl   := hc;
       PTTHotkey_Winkey := hw;
       PTTHotkey_Key    := w;
       lblPreviousTooltipKeyname.caption := s;
    end;
end;




procedure TFrmConfig.cbDisableWatcherClick(Sender: TObject);
begin
    if FrmChainWatcher <> nil then begin
        FrmChainWatcher.PermanentDisable(cbDisableWatcher.checked);
    end;
end;

procedure TFrmConfig.cbDisableWhenScrollLockClick(Sender: TObject);
begin
    frmClipboardManager.SetDisableWhenScrollLock(cbDisableWhenScrollLock.checked);
end;


procedure TFrmConfig.cbEnableSoundClick(Sender: TObject);
begin
    if cbEnableSound.Checked then PlaySound_Init;
end;

procedure TFrmConfig.cbDisableSystemTrayIconNotificationClick(
  Sender: TObject);
begin
    FrmSysTrayMenu.SetDisableIconChanges(cbDisableSystemTrayIconNotification.checked);
end;

procedure TFrmConfig.cboCopyClickKeyClick(Sender: TObject);
begin
     FrmMainPopup.SetCopyKey(self.cboCopyClickKey.ItemIndex);
end;

procedure TFrmConfig.cboPermanentClickKeyClick(Sender: TObject);
begin
   FrmMainPopup.SetPermanentKey(self.cboPermanentClickKey.ItemIndex);
end;

procedure TFrmConfig.cboMimicClickKeyClick(Sender: TObject);
begin
    FrmMainPopup.SetMimicKey(self.cboMimicClickKey.ItemIndex);
end;

procedure TFrmConfig.rbCtrlClickRunClick(Sender: TObject);
begin
    FrmMainPopup.SetCtrlClickOpen(rbCtrlClickRun.checked);
end;

procedure TFrmConfig.rbCtrlClickMenuClick(Sender: TObject);
begin
    FrmMainPopup.SetCtrlClickMenu(rbCtrlClickMenu.checked); 
end;

procedure TFrmConfig.tvGroupMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var tn : TTreeNode;
    ht : THitTests;
begin
    ht := tvGroup.GetHitTestInfoAt(X,Y);
    if (htOnIcon in ht) then begin
        tn := tvGroup.GetNodeAt(x,y);
        if tn <> nil then begin
            tn.ImageIndex := tn.ImageIndex xor 1;
            tn.SelectedIndex := tn.ImageIndex;
        end;
    end;
end;

procedure TFrmConfig.tvOptionsChange(Sender: TObject; Node: TTreeNode);
begin
    //self.ShowNewPanel;
    pcPanels.ActivePageIndex := (tvOptions.Selected.AbsoluteIndex);
end;

procedure TFrmConfig.cbShowFormModeClick(Sender: TObject);
begin
    //FrmMainPopup.SetShowFormMode(cbShowFormMode.Checked);
end;





procedure TFrmConfig.cbPopupDoubleclickClick(Sender: TObject);
begin
    if cbPopupDoubleclick.checked then
        cbPopupDoubleclickTray.checked := not cbPopupDoubleclick.checked;
end;

procedure TFrmConfig.cbPopupDoubleclickTrayClick(Sender: TObject);
begin
    if cbPopupDoubleclickTray.checked then
    cbPopupDoubleclick.checked := not cbPopupDoubleclickTray.checked;
end;

procedure TFrmConfig.bntSetFontClick(Sender: TObject);
var ini : TIniFile;
    c : cardinal;
    fs : TFontStyles;
begin
    if FontDialog.Execute then begin
        FrmDummyUnicodePopup.Font := FontDialog.Font;

        ini := TInifile.Create( self.GetINIFileName );

        //
        // Hotkey Panel
        //
        ini.WriteString('Font','Name', FontDialog.Font.Name);
        ini.WriteInteger('Font','CharSet', FontDialog.Font.Charset);
        ini.WriteInteger('Font','Color', FontDialog.Font.Color);
        ini.WriteInteger('Font','Size', FontDialog.Font.Size);

        fs :=FontDialog.Font.style;
        move(fs, c, 4);
        ini.WriteInteger('Font','Style', c);
        FrmDummyUnicodePopup.Font.Style := fs;
    end;
end;


procedure TFrmConfig.XcbShowAllItemsClick(Sender: TObject);
begin
    if cbShowAllItems.Checked then begin
        self.cbShowAllAsSubmenus.Checked := false;
    end;
end;

procedure TFrmConfig.XcbShowAllAsSubmenusClick(Sender: TObject);
begin
    if cbShowAllAsSubmenus.Checked then begin
        self.cbShowAllItems.Checked := false;
    end;
end;

function TFrmConfig.GetPreCaptureDelayMS: integer;
begin
    result := PreCaptureDelayMS;
end;

procedure TFrmConfig.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    if (KEY = VK_ESCAPE) then begin
        self.btnCancel.Click;
    end;
end;

procedure TFrmConfig.txtRecentlyRemovedChange(Sender: TObject);
begin
    try
        udRecentlyRemoved.Position := StrToInt(txtRecentlyRemoved.Text);
        UnitClipQueue.TempClipQueue.SetQueueSize(udRecentlyRemoved.Position);
        UnitClipQueue.ResyncTempClipQueue;
    except
    end;
end;





procedure MoveListViewItem(lv: TListView; old, new : integer);
var lisource, lidest: TListItem;
begin
    if old < new then begin
        MoveListViewItem(lv, new, old);
        EXIT;
    end;
    lv.Items.BeginUpdate;
    try
        lisource := lv.Items[old];
        lidest := lv.Items.Insert(new);
        lidest.Assign(lisource);
        lisource.Free;
    finally
        lv.Items.EndUpdate;
    end;
end;

procedure TFrmConfig.SpeedButton1Click(Sender: TObject);
var i : integer;
begin
    if lvFormats.Selected = nil then EXIT;
    i := lvFormats.Selected.Index;
    if i = 0 then EXIT;

    MoveListViewItem(lvFormats, i, i - 1 );

    lvFormats.Selected := lvFormats.Items[i - 1];
    lvFormats.ItemFocused := lvFormats.Selected;
end;

procedure TFrmConfig.SpeedButton2Click(Sender: TObject);
var i : integer;
begin
    if lvFormats.Selected = nil then EXIT;
    i := lvFormats.Selected.Index;
    if i = lvFormats.items.count - 1  then EXIT;

    MoveListViewItem(lvFormats, i, i + 1 );

    lvFormats.Selected := lvFormats.Items[i + 1];
    lvFormats.ItemFocused := lvFormats.Selected;
end;

procedure TFrmConfig.SpeedButton3Click(Sender: TObject);
var i : integer;
begin
    if lvOrder.Selected = nil then EXIT;
    i := lvOrder.Selected.Index;
    if i = 0 then EXIT;

    MoveListViewItem(lvOrder, i, i - 1 );

    lvOrder.Selected := lvOrder.Items[i - 1];
    lvOrder.ItemFocused := lvOrder.Selected;
end;

procedure TFrmConfig.SpeedButton4Click(Sender: TObject);
var i : integer;
begin
    if lvOrder.Selected = nil then EXIT;
    i := lvOrder.Selected.Index;
    if i = lvOrder.items.count - 1  then EXIT;

    MoveListViewItem(lvOrder, i, i + 1 );

    lvOrder.Selected := lvOrder.Items[i + 1];
    lvOrder.ItemFocused := lvOrder.Selected;
end;


function TFrmConfig.FormatCount: integer;
var i : integer;
begin
    result := 0;
    for i := 0 to lvFormats.Items.count - 1 do begin
        if lvFormats.Items[i].Checked then inc(result);
    end;
end;

function TFrmConfig.GetFormat(index: integer): FormatOrder;
var i, j, found : integer;
    s : string;
begin

    // find the index of the N-th checked item
    j := -1;
    for i := 0 to lvFormats.Items.count - 1 do begin
        if lvFormats.Items[i].Checked then inc(j);
        if j = index then begin
            j := i;
            BREAK;
        end;
    end;

    s := lvFormats.Items[j].Caption;
    result := FO_UNICODE;
    if s = 'Unicode' then result := FO_UNICODE;
    if s = 'RichText' then result := FO_RICHTEXT;
    if s = 'HTML' then result := FO_HTML; 
end;

end.






