unit UnitFrmDummyClipboardBar;

// NOTES: There's no good place to hook into for loading the state

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, UnitFrmDummyUnicodeTooltip, UnitClipQueue, clipbrd;

type
  TfrmDummyClipboardBar = class(TForm)
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    clipbar : TTooltipDragWindow;
    showbar : boolean;
    clip : TClipItem;
  public
    { Public declarations }
    procedure NewClipFound;
    procedure SetVisible(vis : boolean);
    function IsVisible : boolean;

    procedure GetSizePos(var x: integer; var y : integer; var width : integer;  var height: integer);
    procedure SetSizePos(x,y,width,height : integer);
  end;

var
  frmDummyClipboardBar: TfrmDummyClipboardBar;

implementation

uses UnitFrmConfig;

{$R *.dfm}

procedure TfrmDummyClipboardBar.FormCreate(Sender: TObject);
begin
    clipbar := TTooltipDragWindow.Create;
    //self.showbar := true;
    clip := TClipItem.create;


end;



function TfrmDummyClipboardBar.IsVisible: boolean;
begin

    self.showbar := clipbar.isshowing;
    result := self.showbar;
end;

procedure TfrmDummyClipboardBar.NewClipFound;
var top, left : integer;
    r : TRect;
begin

    // show new contents
    if clipbar.IsShowing then begin
        windows.GetWindowRect(clipbar.Handle,r);
        top := r.top;
        left := r.Left;

        clipbar.CloseTooltip();
        clip.GetClipboardItem(0);
        clipbar.showtooltip(clip,point(left,top),'',false);
    end;
end;

procedure TfrmDummyClipboardBar.SetSizePos(x, y, width, height: integer);
var top, left : integer;
    r : TRect;
begin

    // show new contents
    if clipbar.IsShowing then begin

        clipbar.CloseTooltip();
        clip.GetClipboardItem(0);

        clipbar.Top := y;
        clipbar.Left := x;
        clipbar.Width := width;
        clipbar.Height := height;
        clipbar.SetMaxWidth(width);
        clipbar.SetMaxHeight(height);

        clipbar.showtooltip(clip,point(x,y),'',false);

        {clipbar.Invalidate;
        clipbar.Repaint;
        clipbar.Update;}
    end;
end;

procedure TfrmDummyClipboardBar.GetSizePos(var x: integer; var y : integer; var width : integer;
  var height: integer);
var r : TRect;
begin
    if clipbar.IsShowing then begin
        windows.GetWindowRect(clipbar.Handle,r);

        y := clipbar.Top;
        x := clipbar.Left;

        width := r.Right - r.left;
        height := r.bottom - r.Top;



    end;
end;


procedure TfrmDummyClipboardBar.SetVisible(vis: boolean);
var r : TRect;
begin
    self.showbar := vis;
    if not showbar then begin
        clipbar.CloseTooltip()
    end else begin
        clipbar.Top := mouse.CursorPos.Y + 20;
        clipbar.Left := mouse.CursorPos.x + 20;
        //self.NewClipFound;

        windows.GetWindowRect(clipbar.Handle,r);
        top := r.top;
        left := r.Left;
        clipbar.CloseTooltip();
        clip.GetClipboardItem(0);
        clipbar.showtooltip(clip,point(left,top),'',false);
    end;
end;

end.
