unit UnitFrmMainPopup;
{
    This unit displays the main popup menu when a hotkey is pressed

    UnitFrmConfig is responsible for setting/releasing the hotkey -
    I had a good reason why, but I don't remeber it. I think there
    was a circular reference where each form required the other during
    creation.


    NOTE:
    Ignore the clipboard from Hotkey until Popup Dismissal
    Ignore the clipboard from paste start until paste end

    Inform the FrmClipboardManager any time we paste an item.
    (in routines SendText and OtherItemClickEvent)




Update:
    Fix to detect accidental single/double click on System Tray Icon to show popup
    Show "Paste as Plain Text" when pasting as Complex Item by default

    ----------------------
    Mouse Position always used no matter the configuration
    Problem pasting from ArsClip into ArsClip

    ---------------------
    "All Items..." support
    Default mouse position when carat not found - Mozilla tweak

    --------------------
    Fixed duplicate hotkey detection to work with the Tooltip Popup hotkeys
    --------------------
    Changed to allow ArsClip to paste into its own windows, like
    Permanent Items. (Relies on new 'place on clipboard' method
    ArsClip uses)

    --------------------
    Duplicate Hotkey message detection
    Optional paste as Complex Item

    --------------------
    "Current:" item for text & nontext items
    Updates to paste Permanent Items with embeded keystrokes

    --------------------
    New CTRL+Click option for Rich Text - only shown when rich text
    found associated to a text clip.

    Updated for option to show popup on double-click
    Save Removed Items on Close.....
    Handle Tooltip hotkeys
    Tooltips for

    ------
    New Form Mode / Next Field buttons
    Number 1 - 9, 0, A-Z on popup
    --
    Ignore the Hotkey while the Popup is being displayed.

    New secondary popup menu for text items (alternative to
    function key + clicking on items)

    Updated the focus rules for asking the user about "no-paste" windows
    in the hotkey message method.
                  s
    --

    New SHIFT+INSERT pasting method

    Shift + Click to preview a picture (non-text item)
    F1 + Click to copy to clipboard only a non-text item

    Non-text items shown in Newest-To-Oldest order

    Flush non-text items command in Full Mode
    Flush text items command in Full Mode

    --

    Show configured (either on popup or in submenu) for
    permanent item groups in full mode - default to on popup when not
    specified

    New F1+Click to copy to clipboard only
    New F2+Click to make into a new Permanent Item
    Cleaned up special Key+Click code


    New 'Full Mode/Configured Mode' toggle.

    Code cleanup - made SendCTRL_V procedure.

    Allow user to specify "NoPaste" for programs that don't
    have a target control.

    New option for quick-change of Permanent Item groups

    CTRL+Clicks on Menu Items, Last, Current, Permanent Items will open
    files, urls, folders, etc.

    Using UnitClipQueue
    New handling for tabs in the display of clip items
    Focus is now returned when ESC is pressed

}


interface
uses

  UnitFolderWriteTest{},
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Clipbrd, Menus, StrUtils, ShellAPI, ExtCtrls, Buttons,
  IniFiles {for hashed}, UnitTooltipPopup,
   {UnitMyPopup,} UnitClipQueue, UnitTWideChar, XPMan;


  type
  TFrmMainPopup = class(TForm)
    Memo1: TMemo;
    btnHide: TButton;
    imgA: TImage;
    imgRightArrow: TImage;
    imgIcon: TImage;
    imgFull: TImage;
    pmItemOptions: TPopupMenu;
    Run1: TMenuItem;
    MakePermanentItem1: TMenuItem;
    PasteusingMimicTyping1: TMenuItem;
    Placeonclipboard1: TMenuItem;
    Preview1: TMenuItem;
    back1: TMenuItem;
    Cancel1: TMenuItem;
    N2: TMenuItem;
    PasteusingSHIFTINS1: TMenuItem;
    PasteusingCTRLV1: TMenuItem;
    imgPasteAll: TImage;
    imgPaste: TImage;
    imgEdit: TImage;
    imgFlush: TImage;
    imgConfMode: TImage;
    imgPermCasc: TImage;
    imgRemoved: TImage;
    N0RemoveItem: TMenuItem;
    tim: TTimer;
    AMakePermanentas1: TMenuItem;
    N3: TMenuItem;
    EditText1: TMenuItem;
    N0UndeleteItem: TMenuItem;
    ImgUnicode: TImage;
    imgRichText: TImage;
    imgFile: TImage;
    imgPlain: TImage;
    imgHTML: TImage;
    imgUnkown: TImage;
    N4: TMenuItem;
    imgPic: TImage;
    N5: TMenuItem;
    Button1: TButton;
    PasteSubmenu: TMenuItem;
    MakePermanentItem2: TMenuItem;
    ImgMisc: TImage;
    imgAICon: TImage;

    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnHideClick(Sender: TObject);
    procedure Run1Click(Sender: TObject);
    procedure MakePermanentItem1Click(Sender: TObject);
    procedure PasteusingMimicTyping1Click(Sender: TObject);
    procedure Placeonclipboard1Click(Sender: TObject);
        procedure Preview1Click(Sender: TObject);
    procedure back1Click(Sender: TObject);
    procedure PasteusingSHIFTINS1Click(Sender: TObject);
    procedure PasteusingCTRLV1Click(Sender: TObject);
    procedure N0RemoveItemClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure AMakePermanentas1Click(Sender: TObject);
    procedure MimicTyping1Click(Sender: TObject);
    procedure N2SHIFTINSERT1Click(Sender: TObject);
    procedure N3CTRLV1Click(Sender: TObject);
    procedure N4ClipboardOnly1Click(Sender: TObject);
    procedure N5Default1Click(Sender: TObject);
    procedure EditText1Click(Sender: TObject);
    procedure N0UndeleteItemClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure timTimer(Sender: TObject);
    //procedure timTimer(Sender: TObject);
  private
  protected
    { Private declarations }

    HotKeyForeWindow: cardinal;         {target window for text pasting}
    HotKeyTarget: cardinal;             {target control with keyboard focus}
    TargetEXE : string;                  {name of program that created window}
    TargetX, TargetY : integer;
    TargetSelText : string;
    TargetSelectCompatible : boolean;

    Popup: TPopupMenu;                  {text pasting popup}
    PopupShowing : boolean;

    LastStringSelected : string;         {last selected queue item from Popup}
    MenuItemText : string;
    CurrentClipboard : TClipItem;
    SelectedClipboard : TClipItem;
    CTRLClickedItem : TClipItem;

    ThreadOurs : cardinal;               {Used soley by ThreadAttach/Detach}
    ThreadTarget : cardinal;
    ThreadAttached : boolean;

    {configuration options}
    PopupUseKB : boolean;
    UsePermanentItems : boolean;
    DoShowEditHistory : boolean;
    DoShowPasteAll : boolean;
    DoMoveSelectedToTop : boolean;
    DoShowCurrentItem : boolean;
    DoShowPermanentItemGroups : boolean;
    DoShowPermanentItemSubmenu : boolean;
    DoRememberHistory : boolean;
    DoShowLast : boolean;
    DoShowFormMode : boolean;
    IgnoreHotkey : boolean;

    {UsePermanentItemsMore : boolean;
    PermanentItemsToShow : integer;}
    PermanentItemsCurrentTop : integer;

    {keystrokes monitored when an item is clicked}
    CopyKey : integer;
    PermanentKey : integer;
    MimicKey : integer;

    {non-text items}
    UseOtherClipboardOnly : boolean;
    UseOtherPasting : boolean;
    UseFormMode : boolean;
    UseCtrlClickOpen, UseCtrlClickMenu : boolean;
    UseMousePositionOnce : boolean;

    FullMode : boolean; // user pressed Full Mode command
    PermanentItemPressed : boolean;


    TooltipPopup : TTooltipPopup;
    HotkeyActive : boolean;
    PopupActive : boolean;

    ItemMenuOverride : boolean;
    //ItemMenuIndex : integer;
    {unicode poup}

    GatherTargetWarned : boolean;
    LastClipboardSequence : cardinal;
    
    procedure HandleCloseEvent;
    procedure HandleFormMode(sendtab : boolean = false);
    function ThreadAttach(TargetWindow: cardinal) : boolean;
    procedure ThreadDetach();

    procedure GatherTargetWindowData(overridehandle : THandle = 0);
    procedure GetTargetControl(ParentWindow: cardinal;
        var TargetHandle: cardinal;
        var TargetX: integer;
        var TargetY: integer);

    {
    // possible future use
    procedure MyOnDraw(Sender: TObject; ACanvas: TCanvas;
            ARect: TRect; Selected: Boolean);
    procedure MyOnMeasure(Sender: TObject; ACanvas: TCanvas;
            var Width, Height: Integer);
    }
    procedure ShowPopupWithFocusRules;
    procedure ShowPopup(X,Y: integer);


    //
    // util functions
    //
    procedure ShowPreviewForm;
    procedure PopulatePopupANSI(p : TPopupMenu); virtual; Abstract;
    




  public
    function GetTargetEXE : string;
    procedure SetItemMenuOverride( enabled : boolean );

    procedure ShowItemMenu(s : string; ci : TClipItem = nil);
    function KeyPressedOverride(s : string; ci : TClipItem = nil; fakectrl : boolean = false) : boolean;

    procedure ShowPreviewEditForm;
    procedure ClearCurrentLast;

    {public declarations}
    procedure SendText(s : string; ci : TClipItem = nil; NoPlaintext : boolean = false);
    function GetNextWindow : THandle;
    procedure ShowOnNextWindow(ShowPopup : boolean = true);
    function GetNextWindowProgramName : string;
    {configuration}
    procedure SetPopupUseKeyboard(usekb: boolean);
    procedure SetPermanentItems(DoUse: boolean);
    procedure SetShowPermeanentItemGroups(enable : boolean);
    procedure SetShowPermanentItemSubmenu(value : boolean);

    procedure SetOtherPasteMethodPasting();
    procedure SetOtherPasteMethodClipboardOnly();
    procedure SetShowEditHistory(value : boolean);

    procedure SetShowPasteAll(DoShow: boolean);
    procedure SetMoveSelectedItemToTop(DoMove : boolean);
    procedure SetShowCurrentItem(DoShow: boolean);
    procedure SetRememberHistory(DoRemember: boolean);
    procedure SetDoShowLast(DoShow: boolean);
    procedure SetShowFormMode(DoShow : boolean);
    procedure SetCopyKey(key : integer);
    procedure SetPermanentKey(key : integer);
    procedure SetMimicKey(key : integer);
    procedure SetCtrlClickOpen(value : boolean);
    procedure SetCtrlClickMenu(value : boolean);


    {these are shared with FrmDummyUnicodePopup}
    //
    // menu items selected on Popup window
    //
    function GetUsePermanentItems : boolean;
    function GetDoShowEditHistory : boolean;
    function GetDoShowPasteAll : boolean;
    function GetDoMoveSelectedToTop : boolean;
    function GetDoShowCurrentItem : boolean;
    function GetDoShowPermanentItemGroups : boolean;
    function GetDoShowPermanentItemSubmenu : boolean;
    function GetDoRememberHistory : boolean;
    function GetDoShowLast : boolean;
    function GetDoShowFormMode : boolean;

    function GetLastStringSelected : string;
    function GetUseFormMode : boolean;
    function GetFullMode : boolean;
    function GetAccelerator(i: integer): char;
    function GetTrimmedItem(item : string) : string;
    function GetSelectedText : string;
    procedure ClearSelectedText;
    
    procedure MenuItemClickEvent(Sender: TObject);
    procedure TempMenuItemClickEvent(Sender: TObject);
    procedure ClickedMenuItemClickEvent(Sender: TObject);
    procedure FlushTextItemsClickEvent(Sender: TObject);
    procedure FlushTextItemsClickEventNoPop(Sender: TObject);

    procedure EditHistoryItemClickEvent(Sender : TObject);
    procedure OtherItemClickEvent(Sender: TObject);
    procedure FlushOtherItemsClickEvent(Sender: TObject);
    procedure FlushOtherItemsClickEventNoPop(Sender: TObject);
    procedure LastMenuItemClickEvent(Sender: TObject);
    procedure CancelMenuItemClickEvent(Sender: TObject);
    procedure SearchMenuItemClickEvent(Sender: Tobject);
    procedure SearchJumplistClickEvent();

    procedure PermanentMenuItemClickEvent(sender: TObject); overload;
    procedure PermanentMenuItemClickEvent(sender: TObject; fakectrl : boolean = false); overload;
    procedure PermanentMenuItemClickEvent(s : string; fakectrl : boolean = false); overload;

    procedure PermanentGroupItemClickEvent(sender: TObject); overload;
    procedure PermanentGroupItemClickEvent(s : string); overload;
    procedure PasteAllMenuItemClickEvent(sender: TObject);
    procedure SelectedAllMenuItemClickEvent(sender: TObject);

    procedure PasteSelectedMenuItemClickEvent(sender: TOBject);

    procedure CurrentMenuItemClickEvent(Sender: TObject); overload;
    procedure CurrentMenuItemClickEvent(Sender: TObject; fakectrl : boolean = false); overload;

    procedure FullModeMenuItemClickEvent(Sender : TObject);
    procedure FormModeMenuItemClickEvent(Sender : TObject);
    procedure NextFieldModeMenuItemClickEvent(Sender : TObject);

    {system tray stuff/ windows messages}
    procedure WMHotKey(var Msg : TWMHotKey); message WM_HOTKEY;
    procedure WMEndSession(var msg : TWMQueryEndSession); message WM_QUERYENDSESSION;

    procedure AppendLog(s : string);
    procedure ShowOnSystemTray;

    procedure ApplicationException(Sender: TObject; E: Exception);
    procedure NewClipboardCallback;
  end;

{var
  FrmMainPopup: TFrmMainPopup;}
implementation

uses UnitMisc, UnitFrmConfig, UnitFrmClipboardManager,
  UnitFrmPasteSelected, UnitOtherQueue, UnitKeyboardQuery,
  TLHelp32, UnitFrmPreview, UnitFrmPermanentNew,
  UnitFrmRemoved, UnitFrmSysTrayMenu, UnitPaste, Math,
  CommCtrl, UnitFrmDummyUnicodeTooltip, UnitfrmDummyUnicodePopup,
  UnitFrmEditItem, UnitMenuItemTagdata , UnitFrmSearch, UnitSound
  , UnitFrmDummyClipboardBar;

{$R *.dfm}

CONST PASTE_ONLY_FILE : string = 'nopaste.txt';
const HAS_SELECTED_TEXT : string = '[Has Selected Text]';

{
--========================
-- // Public Interface //
--========================
}

procedure TFrmMainPopup.SetShowFormMode(DoShow : boolean);
begin
    self.DoShowFormMode := DoShow;
end;
procedure TFrmMainPopup.SetCtrlClickOpen(value : boolean);
begin
    self.UseCtrlClickOpen := value;
    self.UseCtrlClickMenu := not value;
end;
procedure TFrmMainPopup.SetCtrlClickMenu(value : boolean);
begin
    self.UseCtrlClickOpen := not value;
    self.UseCtrlClickMenu := value;
end;

procedure TFrmMainPopup.SetMimicKey(key : integer);
begin
    self.MimicKey := VK_F1 + key;
end;
procedure TFrmMainPopup.SetCopyKey(key : integer);
begin
    self.CopyKey := VK_F1 + key;
end;
procedure TFrmMainPopup.SetPermanentKey(key : integer);
begin
    self.PermanentKey := VK_F1 + key;
end;

procedure TFrmMainPopup.SetShowEditHistory(value : boolean);
begin
    self.DoShowEditHistory := value;
end;

procedure TFrmMainPopup.SetShowPermanentItemSubmenu(value : boolean);
begin
    if (value) then begin
        DoShowPermanentItemSubmenu := true;
        DoShowPermanentItemGroups := false;
    end;
end;
procedure TFrmMainPopup.SetShowPermeanentItemGroups(enable : boolean);
begin
    if (enable) then begin
        DoShowPermanentItemSubmenu := false;
        DoShowPermanentItemGroups := true;
    end;
end;
procedure TFrmMainPopup.SetOtherPasteMethodPasting();
begin
    self.UseOtherClipboardOnly := false;
    self.UseOtherPasting := true;
end;
procedure TFrmMainPopup.SetOtherPasteMethodClipboardOnly();
begin
    self.UseOtherClipboardOnly := true;
    self.UseOtherPasting := false;
end;

procedure TFrmMainPopup.SetDoShowLast(DoShow: boolean);
begin
    self.DoShowLast := DoShow;
end;
procedure TFrmMainPopup.SetItemMenuOverride(enabled: boolean);
begin
    self.ItemMenuOverride := enabled;
end;

procedure TFrmMainPopup.SetRememberHistory(DoRemember: boolean);
begin
    self.DoRememberHistory := DoRemember;
end;
procedure TFrmMainPopup.SetShowCurrentItem(DoShow: boolean);
begin
    self.DoShowCurrentItem := doshow;
end;

procedure TFrmMainPopup.SetShowPasteAll(DoShow: boolean);
begin
    self.DoShowPasteAll := DoShow;
end;
procedure TFrmMainPopup.SetPopupUseKeyboard(usekb: boolean);
begin
    self.PopupUseKB := usekb;
end;

procedure TFrmMainPopup.SetPermanentItems(DoUse: boolean);
begin
    self.UsePermanentItems := douse;
end;

procedure TFrmMainPopup.SetMoveSelectedItemToTop(DoMove : boolean);
begin
    DoMoveSelectedToTop := DoMove;
end;


{
--========================
-- // Create/Destroy   //
--========================

Popup menu
NoPaste file
Init vars

Handle a form close or a logoff/shutdown
}


procedure TFrmMainPopup.FormCreate(Sender: TObject);
begin
    UnitMisc.AppendLog('FrmMainPopup - Creating');

    imgIcon.picture.Icon := application.Icon;
    //
    // popup & menu items init
    //
    self.ShowHint := true;
    Popup := TPopupMenu.Create(self);

    TooltipPopup := TTooltipPopup.Create;


    ThreadAttached := false;

    self.CurrentClipboard := TClipItem.Create;
    self.SelectedClipboard := TClipItem.Create;


    if Assigned(FrmConfig) then begin

    end;

end;

procedure TFrmMainPopup.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    self.HandleCloseEvent;
end;

//
// When OS is shutting down/logging off
//
procedure TFrmMainPopup.WMEndSession(var msg : TWMQueryEndSession);
begin
    self.HandleCloseEvent;
    msg.Result := 1;       // do allow close
end;


procedure TFrmMainPopup.HandleCloseEvent;
begin
    if self.DoRememberHistory then begin
        frmClipboardManager.SaveHistory;
    end;

    FrmConfig.SaveClipboardBarState;

    FrmConfig.SaveLastPermPath;
    FrmPermanent.Close;

    MyFree(Self.CurrentClipboard);

    if not Application.Terminated  then begin
        Application.Terminate;
    end;
end;










{
--======================
-- // HotKey Message  //
--======================

Description:
    Find the target control
    - Handle case when no target control
    - allow user to add problematic program to "No Paste" list

    Finally, pass control to  ShowPopupWithFocusRules


info collected here:
    HotKeyForeWindow
    HotKeyTarget
    TargetX
    TargetY
    TargetEXE
}

procedure TFrmMainPopup.WMHotKey(var Msg: TWMHotKey);
label EXIT_CODE;
var mods, key : word;
    procedure WaitOn(key, mods: integer);
    var w : word;
    begin

        if Boolean(mods and key) then begin
            case key of
            MOD_ALT : w := VK_MENU;
            MOD_CONTROL : w := VK_CONTROL;
            MOD_SHIFT : w := VK_SHIFT;
            MOD_WIN : w := 0;
            else
                w := 0;
            end;
            if w = 0 then begin
                KeyboardQuery.WaitUntilRelease(VK_LWIN);
                KeyboardQuery.WaitUntilRelease(VK_RWIN);
            end else begin
                KeyboardQuery.WaitUntilRelease(w);
            end;
        end;
    end;

begin
    // Duplicate message detection
    Windows.SetLastError(ERROR_SUCCESS);
    if (self.HotkeyActive) then begin
        UnitMisc.AppendLog('Duplicate hotkey press detected');
        EXIT;
    end;
    try
        self.HotkeyActive := true;

        // Ignore any hotkeys that don't belong to us
        if (not msg.HotKey = FrmConfig.GetHotKeyID) and
            (not msg.HotKey = FrmCOnfig.GetTTHotKeyID) and
            (not msg.HotKey = FrmCOnfig.GetPTTHotKeyID) and
            (not FrmPermanent.IsHotkeyIdent(msg.hotkey))
            then begin
            //goto EXIT_CODE;
            EXIT;
        end;

        if self.ThreadAttached then begin
            sleep(100);
            if self.ThreadAttached then begin
                UnitMisc.AppendLog('wm_hotkey - thread already attached');
                //goto EXIT_CODE;
                EXIT;
            end;
        end;



        // Ignore the clipboard as soon as the hotkey is pressed
        // Stop ignoring on an error exit
        // Each invididual menu item is responsible to stop ingoring the clipboard
        //frmClipboardManager.SetIgnoreClipboard(true);

        UnitMisc.AppendLog('WM_Hotkey - received');
        if (self.IgnoreHotkey) then begin
            UnitMisc.AppendLog('ignoring hotkey');
            //frmClipboardManager.SetIgnoreClipboard(false);
            //goto EXIT_CODE;
            EXIT;
        end;

        // get current foreground window
        // get the data needed to show the popup from the window

        self.HotKeyForeWindow := Windows.GetForegroundWindow();
        if (self.HotKeyForeWindow = 0) then begin
            ShowMessage('Couldn''t get foreground window');
            //frmClipboardManager.SetIgnoreClipboard(false);
            //goto EXIT_CODE;
            EXIT;
        end;
        self.GatherTargetWindowData;


        // Show the Popup, Next Tooltip, or Previous Toolip
        // or paste current as plain text

        mods := TMessage(msg).LParamLo;
        key := TMessage(msg).LParamHi;

        if (msg.HotKey = FrmConfig.GetHotKeyID)  then begin
            self.FullMode := false;
            KeyboardQuery.WaitUntilRelease(key);
            //WaitOn(MOD_WIN, mods);
            WaitOn(MOD_ALT, mods);


            // it's OK if control is down because we'll send CTRL+C anyways
            // is Copy Selected is enabled
            //WaitOn(MOD_CONTROL, mods);
            //WaitOn(MOD_SHIFT, mods);

            self.ShowPopupWithFocusRules;
        end else if (msg.HotKey = FrmConfig.GetTTHotKeyID) then begin
            self.HotkeyActive := false;
            TooltipPopup.ShowTooltipNext(targetx + 10, targety+20);
        end else if (msg.HotKey = FrmConfig.GetPTTHotKeyID) then begin
            self.HotkeyActive := false;
            TooltipPopup.ShowTooltipPrev(targetx + 10, targety+20);

        end else if (msg.hotkey = FrmConfig.GetPlaintextHokeyID) then begin
            CurrentClipboard.GetClipboardItem(0);

            if (Paste.GetPasteMethod(self.TargetEXE) in [PASTE_MIMIC]) or
            (Paste.GetDefaultPasteMethod in [PASTE_MIMIC]) then begin
                WaitOn(MOD_WIN, mods);
            end;
            // don't paste if a WINKEY is held down

            if CurrentClipboard.GetFormat = CF_HDROP then begin
                Paste.SendText(CurrentClipboard.GetAsText);
            end else begin
                Paste.SendText(Clipboard.AsText);
            end;

        end else if (FrmPermanent.IsHotkeyIdent(msg.hotkey)) then begin
        // otherwise, wait for the hotkeys to be released
            mods := TMessage(msg).LParamLo;
            key := TMessage(msg).LParamHi;

            KeyboardQuery.WaitUntilRelease(key);
            WaitOn(MOD_WIN, mods);
            WaitOn(MOD_ALT, mods);
            WaitOn(MOD_CONTROL, mods);
            WaitOn(MOD_SHIFT, mods);

            FrmPermanent.ReportHotkey(msg.hotkey);
        end;
    finally
        self.HotkeyActive := false;
    end;
end;

procedure TFrmMainPopup.GatherTargetWindowData;
var answer : longint;
    selstart, selend : DWORD;
    length : integer;
    s : string;
begin
    Windows.SetLastError(ERROR_SUCCESS);
    self.GatherTargetWarned := false;

    // find control with focus on foreground window
    // ingore error when pasting option is "Clipboard Only"

    if (overridehandle = 0) then begin
        self.GetTargetControl(self.HotKeyForeWindow, self.HotKeyTarget,
                TargetX, TargetY);

    end else begin
        self.HotKeyForeWindow := overridehandle;
        self.HotKeyTarget := 1;
    end;

    if (FrmConfig.cbDisplayAtMouseCursor.Checked) or (self.UseMousePositionOnce) then begin
        self.UseMousePositionOnce := false;
        TargetX := Mouse.CursorPos.X;
        TargetY := Mouse.CursorPos.Y;
    end;
    self.TargetEXE := WindowHandleToEXEName(self.HotKeyForeWindow);


    Paste.ClearOnceFlags;
    case Paste.GetPasteMethod(self.TargetEXE) of
        PASTE_CTRL_V    :            Paste.SetUsePasteCVOnce;
        PASTE_SHIFT_INS :            Paste.SetUsePasteSIOnce;
        PASTE_MIMIC     :            Paste.SetKeyboardMimicOnce;
        PASTE_CLIPBOARD :            Paste.SetClipboardOnlyOnce;
        PASTE_DEFAULT :
        begin
        end;
    end;


    //
    // Default to mouse position when can't target a control
    //
    if (HotKeyTarget = 0) then begin
        {
        Windows.GetWindowPlacement(self.HotKeyForeWindow, @wp);
        TargetX := wp.rcNormalPosition.Left;
        TargetY := wp.rcNormalPosition.Top;
        }
        TargetX := Mouse.CursorPos.X;
        TargetY := Mouse.CursorPos.Y;

        //
        // Bitch if were not in ClipboardOnly mode
        // or per-program override can't paste the item right by default.
        // Allow user to always use ClipboardOnly for the problematic
        // program
        // [Answer Yes = add EXE name to NoPaste file]
        //

        if (Paste.GetPasteMethod(self.TargetEXE) in [PASTE_CLIPBOARD, PASTE_MIMIC]) or
        (Paste.GetDefaultPasteMethod in [PASTE_CLIPBOARD, PASTE_MIMIC])
         then begin
            self.GatherTargetWarned := true;
            // Lie - we don't need a warning when we're already using non-default paste workarounds
        end;

        if (not (Paste.GetPasteMethod(self.TargetEXE) in [PASTE_CLIPBOARD, PASTE_MIMIC]))
            and
           (not (Paste.GetDefaultPasteMethod in [PASTE_CLIPBOARD, PASTE_MIMIC]))
            then begin

            self.GatherTargetWarned := true;
            Windows.SetForegroundWindow(self.Handle);
            answer := MessageDlg('Coudn''t find control to target in program ' + uppercase(self.TargetEXE) + #13#10
                + 'Would you like to use "Copy to clipboard only" for this program?',
                mtConfirmation, [mbyes, mbno],0 );

            if (answer = mryes) then begin
                //NoPastePrograms.Add(self.TargetEXE);
                Paste.AssignPaste(self.TargetEXE, PASTE_CLIPBOARD);
                Windows.SetForegroundWindow(self.HotKeyForeWindow);
                //frmClipboardManager.SetIgnoreClipboard(false);
                EXIT;
            end;
            //Paste.SetClipboardOnlyOnce;
        end;

        Windows.SetForegroundWindow(self.Handle);
    end;
end;


procedure TfrmMainPopup.GetTargetControl(ParentWindow: cardinal;
    var TargetHandle: cardinal;
    var TargetX: integer;
    var TargetY: integer);
var CaretPos: TPoint;
    Rect: TRect;
    length : integer;
    selstart, selend : dword;
    s : string;
    h : THandle;

    cls : array[0..1023] of char;
begin
    Windows.SetLastError(ERROR_SUCCESS);

    // attempt to get target control's handle and
    // the position of the caret in the text window
    //
    TargetHandle := 0;
    TargetSelText := '';
    if (self.ThreadAttach(ParentWindow)) then begin
        TargetHandle := Windows.GetFocus();
        if (TargetHandle <> 0) then begin
            Windows.GetCaretPos(CaretPos);
            Windows.GetWindowRect(HotKeyTarget, Rect);

            TargetX := Rect.left + CaretPos.X;
            TargetY := Rect.top + CaretPos.Y;


            h := TargetHandle;
        end;

        selstart := 0;
        selend := 0;
        length := Windows.SendMessage(h,EM_GETSEL,integer(@selstart),integer(@selend));
        if length = 0 then begin
            h := HotKeytarget;
            length := Windows.SendMessage(h,EM_GETSEL,integer(@selstart),integer(@selend));
        end;

        self.TargetSelectCompatible := (length <> 0);

        self.TargetSelText := '';
        if (selstart <> selend) and (length <> 0) then begin
            self.TargetSelText := HAS_SELECTED_TEXT;
        end;


        // detect the desktop and ignore
       Windows.GetClassName(ParentWindow,cls, sizeof(cls));
       if (string(cls) = 'Progman') then begin
            self.TargetSelText := '';
            self.TargetSelectCompatible := false;
        end;

        self.ThreadDetach;
    end;
end;





function TFrmMainPopup.GetTargetEXE: string;
begin
    result := self.TargetEXE;
end;

//
// ShowPopupWithFocusRules: Wrapper function to call ShowPopup enforcing the
// focus rules. The rule is to return focus to the original window.
//
// Once the Hotkey has been pressed, you can reshow the
// popup again by calling this procedure.
//
// Program flow continues to a XXXClickEvent routine when the user
// selects an item from the popup window

procedure TFrmMainPopup.ShowPopupWithFocusRules;
var b : boolean;
    s : string;
    c : cardinal;
    i : integer;
begin
    Windows.SetLastError(ERROR_SUCCESS);
    // Attaching to the target keeps the popup from
    // taking away focus from the target item.
    // Example, pasting to the name of a desktop icon. If you remove
    // focus, you remove the rename box


    // we need to be foreground for keyboard focus
    // optionally copy selected data
    self.LastClipboardSequence := 0;
    if frmconfig.CopySelectedForPopup or frmconfig.cbShowEditInstead.checked then begin


        b := frmClipboardManager.GetMonitoring;
        frmClipboardManager.SetDisableMonitoring(true);
        if (self.TargetSelectCompatible) then begin
            // window reported it can detect selected text
            // window reported selected text was available, spinlock
            // until we get it  (maximum of 500ms)
            if (self.TargetSelText = HAS_SELECTED_TEXT) then begin
                self.TargetSelText := ' ...';
                self.LastClipboardSequence := Windows.GetClipboardSequenceNumber;
                Paste.SendCTRL_C;
                i := 0;
                while (LastClipboardSequence = Windows.GetClipboardSequenceNumber)
                    and (i < 500) do begin
                    mysleep(50);
                    inc(i,50);
                end;
                // spinlock for callback
                if (LastClipboardSequence <> Windows.GetClipboardSequenceNumber) then begin
                    i := 0;
                    while (LastClipboardSequence <> 0)
                        and (i < 500) do begin
                        mysleep(50);
                        inc(i,50);
                    end;
                end;
            end;
        end else begin
            if not FrmConfig.cbDontCopySelectedForAll.Checked then begin
                self.TargetSelText := '';
                self.LastClipboardSequence := Windows.GetClipboardSequenceNumber;
                Paste.SendCTRL_C;
                mysleep(100);
            end;
        end;

        frmClipboardManager.SetDisableMonitoring(not b);

        {if c <> Windows.GetClipboardSequenceNumber then begin
            self.SelectedClipboard.GetClipboardItem(0);
            self.TargetSelText := self.SelectedClipboard.GetAsText;
        end else begin
            self.TargetSelText := '';
        end;}


    end;

    if (frmconfig.cbShowEditInstead.checked and (self.TargetSelText <> '')) then begin
        self.SelectedAllMenuItemClickEvent(self);
        EXIT;
    end;

    if (self.PopupUseKB) then begin


        // make sure focus is returned
        if (self.ThreadAttach(self.HotKeyForeWindow)) then begin
            windows.SetForegroundWindow(self.Handle);
            self.ShowPopup(TargetX, TargetY);

            SetForegroundWindow(self.HotKeyForeWindow);
            self.ThreadDetach;
        end else begin
            if (not self.GatherTargetWarned) and
                not (Paste.GetPasteMethod(self.TargetEXE) in [PASTE_CLIPBOARD, PASTE_MIMIC])
              then
                showmessage('Permission denied on target program.');
            // try anyways
            windows.SetForegroundWindow(self.Handle);
            self.ShowPopup(TargetX, TargetY);
            SetForegroundWindow(self.HotKeyForeWindow);
        end;
    end else begin
        if (not self.ThreadAttach(self.HotKeyForeWindow)) then begin
            ShowMessage('ERROR: Couldn''t attach popup menu to this window');
            //frmClipboardManager.SetIgnoreClipboard(false);
            exit;
        end;

        self.ShowPopup(TargetX, TargetY);
        self.ThreadDetach();
    end;
    self.LastClipboardSequence := 0;
end;

procedure TFrmMainPopup.NewClipboardCallback;
begin
    if (self.LastClipboardSequence <> 0)  then begin
        self.SelectedClipboard.GetClipboardItem(0);
        self.TargetSelText := self.SelectedClipboard.GetAsText;
        self.LastClipboardSequence := 0;
    end;
end;




procedure TfrmMainPopup.ShowPopup(X,Y: integer);
    //var lastaddcount : integer;
begin
    self.IgnoreHotkey := true;
    if (self.PopupActive) then begin
        EXIT;
    end;
    self.PopupActive := true;


    if not frmSysTrayMenu.GetJustSwitched then begin
        FrmPermanent.AutoSwitch(self.TargetEXE);
    end;



    UnitMisc.AppendLog('Populate Popup');
    PopulatePopupANSI(popup);

    UnitMisc.AppendLog('Popup Activated');
    FrmDummyUnicodePopup.ShowPopup(x,y, popup);

    UnitMisc.AppendLog('Popup End');
    //
    // show
    // NOTE: This code finishes before .SendText() is ever executed
    //       I need to stop ignoring here because the popup can be dismissed
    //       by ESC key or focus lost.
    //frmClipboardManager.SetIgnoreClipboard(false);
    self.IgnoreHotkey := false;
    self.PopupActive := false;
end;

//
// create a 1..9/0 keys for items 0 to 9 and A to Z keys for items 10 and so no
//
function TFrmMainPopup.GetAccelerator(i: integer): char;
const other : array[37..46] of char = (
    '-', '=',
    '[', ']', '\',
    ';', '''',
    ',', '.', '/'
);
begin
    result := ' ';

    case (i) of
    0..8: result := chr(byte('1') + i);
    9:    result := '0';
    10..36 : result := chr(byte('A') + (i - 10));
    37..46 : result := other[i];
    end;
end;

// show a ' ...' when item is too long
// handle tabs  and handle ampersans
function TFrmMainPopup.GetTrimmedItem(item : string) : string;
begin
    result := item;
    if (length(result) > 200) then begin
        result := leftstr(item, 200) + '...';
    end;

    // tabs make the windows too damn long
    // the #10 will make a funky box in the tab's place
    while pos(#9#9, result) > 0 do begin
        result := stringreplace(result, #9#9, #9, [rfreplaceall]);
    end;
    result := stringreplace(result, #9,#10, [rfReplaceAll]);
    while pos(#10#10, result) > 0 do begin
        result := stringreplace(result, #10#10, #10, [rfreplaceall]);
    end;

    //result := stringreplace(result, #13,#10, [rfReplaceAll]);
    result := stringreplace(result, '&', '&&', [rfReplaceAll]);
end;









procedure TFrmMainPopup.FormShow(Sender: TObject);
begin
    UnitMisc.FlushLog;
end;










{
--============================
-- // Popup MenuItem Clicks //
--============================

Description:

Handle a normal menu item,
other item,
'cancel' item,
Last item,
Current item,
Paste All,
Paste Selected,
Permanent item

Text item make use of the SendText routing to enforce configuration
option.

Remember the last selected text item for the 'last' menu item option.

Inform the clipboard manager of any pasting we do.
}


//
// KeyPressedOverride
// Returns TRUE when an alternate action has taken place
// because of a KEYSTROKE+Click action by the user
// Returns FALSE when no override took place
//
function TFrmMainPopup.KeyPressedOverride(s : string; ci : TClipItem = nil; fakectrl : boolean = false) : boolean;
    //
    // run text as shell command
    // or show CTRL+Click menu
    //
    function CTRLOpen(s : string) : boolean;
    begin
        result := true;

        // detect held CTRL key
        // Execute item or show menu
        if (KeyboardQuery.IsPressed(VK_CONTROL)) or fakectrl or self.ItemMenuOverride then begin
            if (self.UseCtrlClickMenu) or fakectrl or self.ItemMenuOverride then begin
                self.ShowItemMenu(s, ci);
            end else begin
                //
                // use the CTRL+Click Menu to do this
                //
                self.Run1.Click;
            end;
            EXIT;
        end;
        result := false;
    end;


    //
    //  Show a preview of item when SHIFT-Clicked
    //
    function SHIFTOpen(s : string) : boolean;
    begin
        result := true;
        if (KeyboardQuery.IsPressed(VK_SHIFT)) then begin

            self.Preview1.Click;
            EXIT;
        end;
        result := false;
    end;

    function CopyKeyOpen(s : string) : boolean;
    begin
        //
        // just turn on "Paste Only" toggle and let
        // selected menu item handle sending the text as normal
        //
        if (KeyboardQuery.IsPressed(self.CopyKey)) then begin
            Paste.SetClipboardOnlyOnce;
        end;
        result := false;
    end;

    function PermanentKeyOpen(s : string) : boolean;
    begin
        //
        // Show Permanent Items dialog with new entry
        //
        result := true;
        if (KeyboardQuery.IsPressed(Self.PermanentKey)) then begin
            Windows.SetForegroundWindow(FrmPermanent.Handle);
            frmPermanent.ShowWithNewItem(s);
            EXIT;
        end;
        result := false;
    end;

    function MimicKeyOpen(s : string) : boolean;
    begin
        // just turn on "Mimic Typing" toggle and let
        // selected menu item handle sending the text as normal
        if (KeyboardQuery.IsPressed(self.MimicKey)) then begin
            Paste.SetKeyboardMimicOnce;
        end;
        result := false;
    end;
begin
    if fakectrl or self.ItemMenuOverride then begin
        self.CTRLClickedItem := ci;
        if ci <> nil then begin
            MenuItemText := self.CTRLClickedItem.GetAsText;
        end else begin
            MenuItemText := s;
        end;
        self.LastStringSelected := MenuItemText;

        result := CTRLOpen(s);
        EXIT;
    end;

    result := CTRLOpen(s);
    if (result) then EXIT;

    result := SHIFTOpen(s);
    if (result) then EXIT;

    result := CopyKeyOpen(s);
    if (result) then EXIT;

    result := MimicKeyOpen(s);
    if (result) then EXIT;

    result := PermanentKeyOpen(s);
    if (result) then EXIT;

end;

procedure TFrmMainPopup.ShowPreviewForm;
begin
    Windows.SetForegroundWindow(FrmPreview.Handle);

    FrmPreview.Left := Self.TargetX;
    FrmPreview.Top := Self.TargetY;
    FrmPreview.ShowModal;
    if FrmPreview.ModalResult = mrok then
        self.ShowPopupWithFocusRules;
end;


procedure TfrmMainPopup.MenuItemClickEvent(Sender: TObject);
var //s : string;
    //i : integer;
    pasted : boolean;
    mitd : TMenuItemTagData;
begin

    //
    // The item is passed is a TMenuItem by default, but
    // my hacked Unicode popup isn't that smart
    //
    if (Sender is TMenuItem) then begin
        mitd := TagDataList.Get( TMenuItem(sender).tag);

        self.CTRLClickedItem := mitd.clip;
        MenuItemText := '';
        if self.CTRLClickedItem.HasText or (self.CTRLClickedItem.GetFormat = CF_HDROP)  then
            MenuItemText := self.CTRLClickedItem.GetAsText;
        if MenuItemText <> '' then
            self.LastStringSelected := MenuItemText;
    end else begin
        EXIT;
    end;

    UnitMisc.AppendLog('MenuItem format=' + self.CTRLClickedItem.GetFormatName );
    if (self.KeyPressedOverride(MenuItemText, self.CTRLClickedItem)) then begin
        EXIT;
    end;

    //LastStringSelected := mitd.text;
    if (self.DoMoveSelectedToTop) then
        ClipQueue.MoveToStart( ClipQueue.IndexOf(self.CTRLClickedItem) );

    ClickedClipQueue.InsertAtStart( self.CTRLClickedItem.CloneClip );
    //
    // Legacy Note: The ClipItem may have no handle and no format and may
    // only contain the plain text version of an item
    //
    pasted := false;
    if (self.CTRLClickedItem  <> nil) and (self.CTRLClickedItem.GetFormat <> 0) then begin
        if (not Paste.GetKeyboardMimicOnce) then begin
            if (self.CTRLClickedItem.GetFormat = Windows.CF_UNICODETEXT) or
                (FrmConfig.cbPasteComplex.checked) then begin
                UnitMisc.AppendLog('Sending UNICODE by default ');
                self.SendText('', self.CTRLClickedItem);
                pasted := true;
                UnitMisc.AppendLog('inserting done');
            end;
        end;
    end;
    if (not pasted) then begin
        UnitMisc.AppendLog('Sending plaing text ');

        if MenuItemText = '' then begin
            // TODO: check for non-text item paste method
            self.SendText('',self.CTRLClickedItem); 
        end else begin
            self.SendText(MenuItemText);
        end;
        UnitMisc.AppendLog('inserting done');
    end;


    self.HandleFormMode;
end;

procedure TFrmMainPopup.TempMenuItemClickEvent(Sender: TObject);
var s : string;
    mitd : TMenuItemTagData;
begin
    //
    // The item is passed is a TMenuItem by default, but
    // my hacked Unicode popup isn't that smart
    //
    if (Sender is TMenuItem) then begin
        with Sender as TMenuItem do begin
            mitd := TagDataList.Get(tag);
            self.CTRLClickedItem  := mitd.clip;
            s := mitd.text;
        end;
    end;
    if (self.KeyPressedOverride(s, self.CTRLClickedItem)) then begin
        EXIT;
    end;

    //
    // Legacy Note: The ClipItem may have no handle and no format and may
    // only contain the plain text version of an item
    //

    if (self.CTRLClickedItem  <> nil) and (self.CTRLClickedItem.GetFormat <> 0) then begin
        if frmconfig.cbMoveFirst.checked then begin
            frmClipboardManager.DisablePasteProtectionOnce;
        end;
        self.SendText('', self.CTRLClickedItem);
    end else begin
        self.SendText(s, nil);
    end;

    self.HandleFormMode;
end;


procedure TFrmMainPopup.ClickedMenuItemClickEvent(Sender: TObject);
var s : string;
    mitd : TMenuItemTagData;
begin
    //
    // The item is passed is a TMenuItem by default, but
    // my hacked Unicode popup isn't that smart
    //
    if (Sender is TMenuItem) then begin
        with Sender as TMenuItem do begin
            mitd := TagDataList.Get(tag);
            self.CTRLClickedItem  := mitd.clip;
            s := mitd.text;
        end;
    end;
    if (self.KeyPressedOverride(s, self.CTRLClickedItem)) then begin
        EXIT;
    end;


    //
    if ClickedClipQueue.IndexOf(self.CTRLClickedItem) <> -1 then
        ClickedClipQueue.MoveToStart( ClipQueue.IndexOf(self.CTRLClickedItem) );

    //
    // Legacy Note: The ClipItem may have no handle and no format and may
    // only contain the plain text version of an item
    //

    if (self.CTRLClickedItem  <> nil) and (self.CTRLClickedItem.GetFormat <> 0) then begin
        if frmconfig.cbMoveFirst.checked then begin
            frmClipboardManager.DisablePasteProtectionOnce;
        end;
        self.SendText('', self.CTRLClickedItem);
    end else begin
        self.SendText(s, nil);
    end;

    self.HandleFormMode;
end;


procedure TFrmMainPopup.FlushOtherItemsClickEventNoPop(Sender: TObject);
begin
    OtherQueue.ClearQueue;
end;

procedure TFrmMainPopup.FlushTextItemsClickEventNoPop(Sender: TObject);
begin
    ClipQueue.ClearQueue;

end;


procedure TFrmMainPopup.FlushOtherItemsClickEvent(Sender: TObject);
begin
    OtherQueue.ClearQueue;
    self.ShowPopupWithFocusRules;
end;

procedure TFrmMainPopup.FlushTextItemsClickEvent(Sender: TObject);
begin
    ClipQueue.ClearQueue;


    self.ShowPopupWithFocusRules;
end;


procedure TFrmMainPopup.EditHistoryItemClickEvent(Sender : TObject);
begin
    // show the edit window
    // re-show the popup when the edit window it closed
    Windows.SetForegroundWindow(frmClipboardManager.Handle);
    frmClipboardManager.ShowModal;
    self.ShowPopupWithFocusRules;
end;

procedure TFrmMainPopup.OtherItemClickEvent(Sender: TObject);
var ci : TClipItem;
    mitd : TMenuItemTagData;
begin
    if (Sender is TMenuItem) then begin
        mitd := TagDataList.Get(TMenuItem(sender).tag);
        ci := mitd.clip;

    {
    end else begin
        ci := TClipItem(Sender);
    }
    end else begin
        EXIT;
    end;

    // preview only
    if (KeyboardQuery.IsPressed(VK_SHIFT)) then begin
        FrmPreview.SetPicture;
        ci.GetDIB(FrmPreview.imgPreview.picture);
        self.ShowPreviewForm;
        EXIT;
    end;

    // Copy - with no paste

    if (KeyboardQuery.IsPressed(VK_F1)) then begin
        // try to clear phantom keystroke from entering other program
        keybd_event(VK_F1, VkKeyScan(char(VK_F1)), KEYEVENTF_KEYUP, 0);
        Paste.SetClipboardOnlyOnce;
    end;

    ClickedClipQueue.InsertAtStart( ci.CloneClip );

    if (KeyboardQuery.IsPressed(VK_CONTROL) and (self.UseCtrlClickMenu)) or (self.ItemMenuOverride) then begin
        self.CTRLClickedItem := ci;
        ShowItemMenu('', ci);
                         {
        if (self.ThreadAttach(self.HotKeyForeWindow)) then begin
            Windows.SetForegroundWindow(self.Handle);
            self.ThreadDetach;
        end;

        // Show the format in the "Paste as" Menu option
        pmItemOptions.Items[0].Enabled := false;
        pmItemOptions.Items[0].Caption := '&0  [no "paste as" format]';
        pmItemOptions.Items[9].Enabled := false;
        pmItemOptions.Items[9].Caption := '&A  [no complex format]';

        self.CTRLClickedItem := ci;
        if (self.CTRLClickedItem <> nil) then begin
            pmItemOptions.Items[0].Enabled  := true;
            pmItemOptions.Items[0].Caption := '&0  Paste' + self.CTRLClickedItem.GetFormatName;
            pmItemOptions.Items[9].Enabled := true;
            pmItemOptions.Items[9].Caption := '&A  Make Permanent as ' + self.CTRLClickedItem.GetFormatName;
        end;

        pmItemOptions.Items.RethinkHotkeys;
        pmItemOptions.Items[1].Caption := '[no run format]';
        pmItemOptions.Items[1].Caption := '&1  Run ...';
        pmItemOptions.Popup(self.TargetX, self.TargetY );

        // make sure focus is returned
        if (self.ThreadAttach(self.HotKeyForeWindow)) then begin
            SetForegroundWindow(self.HotKeyForeWindow);
            self.ThreadDetach;
        end;         }
    end else begin
        Paste.SendText('', ci, true);
    end;

    // try to clear phantom keystroke from entering other program
    keybd_event(VK_F1, VkKeyScan(char(VK_F1)), KEYEVENTF_KEYUP, 0);
end;


procedure TFrmMainPopup.CurrentMenuItemClickEvent(Sender: TObject);
begin
    self.CurrentMenuItemClickEvent(sender, false)
end;

procedure TFrmMainPopup.CurrentMenuItemClickEvent(Sender: TObject; fakectrl: boolean);
begin
    if (KeyboardQuery.IsPressed(VK_SHIFT)) then begin
        if (self.CurrentClipboard.GetFormat = CF_DIB) then begin
            FrmPreview.SetPicture;
            self.CurrentClipboard.GetDIB(FrmPreview.imgPreview.picture);
            self.ShowPreviewForm;
            EXIT;
        end;
    end;

    self.CTRLClickedItem := self.CurrentClipboard;
    if (self.KeyPressedOverride('', self.CurrentClipboard, fakectrl)) then begin
        EXIT;
    end;

    UnitMisc.AppendLog('Sending Current Item ');
    self.SendText('', self.CurrentClipboard);
    UnitMisc.AppendLog('inserting done');
end;

procedure TFrmMainPopup.SearchJumplistClickEvent;
var p : TPosition;
    b, dis : boolean;
    s, newclip : string;
    i : integer;
    c1, c2 : Cardinal;
    h : THandle;
begin


    //b := self.ThreadAttach(Windows.GetForegroundWindow);
    frmSearch.StatusBar1.SimpleText := 'Pasting to Clipboard only';
    p := frmSearch.Position;
    frmSearch.Position := poScreenCenter;
    frmSearch.Left := mouse.CursorPos.X;
    frmSearch.Top := mouse.cursorpos.y;
    Windows.SetForegroundWindow(FrmSearch.Handle);
    Windows.SetForegroundWindow(FrmSearch.Handle);
    frmSearch.ShowModal;
    frmSearch.Position := p;
    //if b then self.ThreadDetach;



    frmSearch.StatusBar1.SimpleText := '';
    if FrmSearch.ModalResult = mrOK then begin
        newclip := frmSearch.GetTextToPaste;
        if newclip <> '' then begin
            Paste.SetClipboardOnlyOnce;
            self.SendText(newclip);
        end;
    end;

end;

procedure TFrmMainPopup.SearchMenuItemClickEvent(Sender: Tobject);
var p : TPosition;
    b, dis : boolean;
    s, newclip : string;
    i : integer;
    c1, c2 : Cardinal;
begin

    Paste.SendCTRL_SHIFT_LEFT;
    dis := frmClipboardManager.GetMonitoring;
    frmClipboardManager.SetDisableMonitoring(true);
    //frmClipboardManager.IgnoreClipboardOnce;

    c1 := Windows.GetClipboardSequenceNumber;
    Paste.SendCTRL_C;

    // detect new text on the clipboard for a maximum of 500 MS
    for i := 0 to 19  do begin
        c2 := Windows.GetClipboardSequenceNumber;
        if c1 <> c2 then BREAK;
        sleep(25);
    end;
    //Paste.SendCTRL_RIGHT;

    frmClipboardManager.SetDisableMonitoring(not dis);
    
    FrmSearch.txtFind.Text := '';
    if (c1 <> c2) then begin
        s := Clipboard.AsText;

        FrmSearch.txtFind.Text := s;
        FrmSearch.txtFind.SelectAll;
    end;


    b := self.ThreadAttach(windows.GetForegroundWindow);
    Windows.SetForegroundWindow(FrmSearch.Handle);


    p := frmSearch.Position;
    frmSearch.Position := poScreenCenter;
    frmSearch.Left := mouse.CursorPos.X;
    frmSearch.Top := mouse.cursorpos.y;
    frmSearch.ShowModal;
    frmSearch.Position := p;
    SetForegroundWindow(self.HotKeyForeWindow);
    if b then self.ThreadDetach;



    if FrmSearch.ModalResult = mrOK then begin
        newclip := frmSearch.GetTextToPaste;

        if FrmSearch.txtFind.text  <> s  then
            Paste.SendCTRL_RIGHT;

        if newclip <> '' then begin
            self.SendText(newclip);
        end;
    end;



end;

procedure TFrmMainPopup.SelectedAllMenuItemClickEvent(sender: TObject);
var p : TPosition;
    b : boolean;
begin

    b := self.ThreadAttach(windows.GetForegroundWindow);

    FrmEditItem.SetText(self.TargetSelText, nil);
    Windows.SetForegroundWindow(FrmEditItem.Handle);

    p := FrmEditItem.Position;
    FrmEditItem.Position := poScreenCenter;
    FrmEditItem.Left := mouse.CursorPos.X;
    FrmEditItem.Top := mouse.cursorpos.y;
    FrmEditItem.ShowModal;
    FrmEditItem.Position := p;

    if b then self.ThreadDetach;

end;


procedure TfrmMainPopup.LastMenuItemClickEvent(Sender: TObject);
begin
    UnitMisc.AppendLog('Inserting last selected string');
    if (self.KeyPressedOverride(LastStringSelected)) then begin
        EXIT;
    end;
    self.SendText(LastStringSelected);
end;

procedure TfrmMainPopup.CancelMenuItemClickEvent(Sender: TObject);
begin
    // since using the keyboard takes away focus from the target
    // window, it must be returned
    if (self.PopupUseKB) then begin
        if (self.ThreadAttach(self.HotKeyForeWindow)) then begin
            Windows.SetForegroundWindow(self.HotKeyForeWindow);
            self.ThreadDetach;
        end;
    end;

    self.UseFormMode := false;
end;


procedure TFrmMainPopup.ClearCurrentLast;
begin
    self.CurrentClipboard.Free;
    self.CurrentClipboard := TClipItem.Create;
    self.LastStringSelected := '';
end;

procedure TFrmMainPopup.ClearSelectedText;
begin
    self.TargetSelText := '';
end;

procedure TfrmMainPopup.PermanentMenuItemClickEvent(sender: TObject);
begin
    self.PermanentMenuItemClickEvent(sender, false);
end;

procedure TfrmMainPopup.PermanentMenuItemClickEvent(sender: TObject; fakectrl : boolean = false);
var mitd : TMenuItemTagData;
begin
    self.PermanentItemPressed := true;
    mitd := TagDataList.Get( TMenuItem(sender).tag);

    if (mitd.PermanentGroupID  <> - 1) then begin
        FrmPermanent.PermFolderPush;
        FrmPermanent.SetPermanentPath(FrmPermanent.PermFoldersGetItem(mitd.PermanentGroupID));
    end;
    self.CTRLClickedItem := nil;
    if FrmPermanent.IsComplexItem(mitd.text) then begin
        self.CTRLClickedItem := FrmPermanent.GetComplexItem(mitd.text);
    end;

    self.PermanentMenuItemClickEvent(mitd.text, fakectrl);

{ TODO : MEMORY LEAK HERE - fix me please }    //
    //myfree(self.CTRLClickedItem);

    if (mitd.PermanentGroupID <> -1) then begin
        FrmPermanent.PermFolderPop;
    end;

    self.PermanentItemPressed := false;
end;

procedure TFrmMainPopup.PermanentMenuItemClickEvent(s: string; fakectrl : boolean = false);
begin
    MenuItemText := s;
    if (self.KeyPressedOverride(s,self.CTRLClickedItem,fakectrl)) then begin
        EXIT;
    end;
    self.SendText( s );
    self.HandleFormMode;
end;

procedure TFrmMainPopup.PermanentGroupItemClickEvent(sender: TObject);
var
    mitd : TMenuItemTagData;
begin
    with sender as tmenuitem do begin
        mitd := TagDataList.Get(tag);
    end;

    self.PermanentGroupItemClickEvent( FrmPermanent.PermFoldersGetItem(mitd.PermanentGroupID) );
end;

procedure TFrmMainPopup.PermanentGroupItemClickEvent(s: string);
begin
    // Explicitly assign the permanent group to the current EXE
    frmPermanent.SetPermanentPath(s);
    FrmPermanent.AssignPIG(self.TargetEXE);

    self.ShowPopupWithFocusRules;
end;




procedure TfrmMainPopup.PasteAllMenuItemClickEvent(sender: TObject);
var i : longint;
    s : string;
begin
    s := '';
    for i := 0 to (ClipQueue.GetQueueCount  - 1) do begin
        if (Cardinal(i) = (ClipQueue.GetQueueCount  - 1)) then begin
            s := s + ClipQueue.GetItemText(i);
        end else begin
            s := s + ClipQueue.GetItemText(i) + #13#10;
        end;
    end;

    self.SendText(s);
end;

procedure TfrmMainPopup.PasteSelectedMenuItemClickEvent(sender: TOBject);
var s : string;
    wc : TWideChar;
    ci : TClipItem;


    tt : TToolTipWindow;
begin
    if UnitMisc.UniSupported then begin
        wc := FrmPasteSelected.GetSelectedItemsWide;

        if wc = nil then begin
            self.CancelMenuItemClickEvent(self);
            EXIT;
        end;
        
        {tt := TToolTipWindow.Create;
        tt.ShowTooltip(wc,mouse.CursorPos,false,'Dude');}
    end else begin
        s := FrmPasteSelected.GetSelectedItems;
    end;


    // the above windows takes away focus from target
    // here, so it needs it back before pasting
    if (not self.PopupUseKB) then begin
        self.ThreadAttach(self.HotKeyForeWindow);
        Windows.SetForegroundWindow(self.HotKeyForeWindow);
        self.ThreadDetach;
    end;
    if UniSupported then begin
        if wc.size <> 0 then begin
            ci := TClipItem.Create;
            ci.SetFromWideChar(wc);
            self.SendText('',ci,true);
        end else begin
            self.CancelMenuItemClickEvent(self);
        end;
    end else begin
        if (s <> '') then begin
            self.SendText(s);
        end else begin
            self.CancelMenuItemClickEvent(self);
        end;
    end;
end;

procedure TFrmMainPopup.FormModeMenuItemClickEvent(Sender: TObject);
begin
    self.UseFormMode := not self.UseFormMode;
    if self.UseFormMode then self.ShowPopupWithFocusRules;
end;




procedure TFrmMainPopup.NextFieldModeMenuItemClickEvent(Sender: TObject);
var b : boolean;
begin
    b := self.UseFormMode;
    self.UseFormMode := true;
    self.HandleFormMode(true);
    self.UseFormMode := b;
end;


procedure TFrmMainPopup.HandleFormMode(sendtab : boolean = false);
var w : word;
begin
    if self.UseFormMode then begin
        // focus back on target window and control
        // press tab
        // get current target window control again
        // re-show the popup
        if (self.PopupUseKB) then begin
            if (self.ThreadAttach(self.HotKeyForeWindow)) then begin
                Windows.SetForegroundWindow(self.HotKeyForeWindow);
                Windows.SetFocus(self.HotKeyTarget);
            end else begin
                showmessage('ERROR: Unable to paste into target');
                exit;
            end;
        end;

        if (sendtab) then begin
            w := VkKeyScan(#9);
            keybd_event(VK_TAB, w, 0, 0);
            sleep(10);
            keybd_event(VK_TAB, w, KEYEVENTF_KEYUP, 0);
            sleep(100);
        end;
        
        if (self.PopupUseKB) then begin
            self.ThreadDetach;
        end;
        self.GetTargetControl(self.HotKeyForeWindow, self.HotKeyTarget,
            TargetX, TargetY);


        self.ShowPopupWithFocusRules;
    end;
end;







procedure TFrmMainPopup.ShowItemMenu(s: string; ci: TClipItem);
var i : integer;
    b : boolean;
begin
    if (self.ThreadAttach(self.HotKeyForeWindow)) then begin
        Windows.SetForegroundWindow(self.Handle);
        self.ThreadDetach;
    end;

    for i := 0 to (pmItemOptions.Items.Count - 1) do begin
        pmItemOptions.Items[i].Enabled := true;
        pmItemOptions.Items[i].Visible := true;
    end;

    // Show the format in the "Paste as" Menu option
   // N0PasteasRichText1.Enabled := false;
   // N0PasteasRichText1.Caption := '&0  [no "paste as" format]';
   // N0PasteasRichText1.Visible := false;


    // no clip object or it's on the popup
    N0UndeleteItem.Visible := false;
    if (ci = nil) or (ClipQueue.IndexOf(ci) = -1)  then begin
        N0RemoveItem.Enabled := false;
    end else begin
        N0UndeleteItem.Visible := false;
    end;

    // it's on the Removed Items list
    N0UndeleteItem.Enabled := false;
    if (ci <> nil) and (TempClipQueue.IndexOf(ci) <> -1) then begin
        N0UndeleteItem.Visible := true;
        N0UndeleteItem.Enabled := true;
        N0RemoveItem.Visible := false;
    end;

    AMakePermanentas1.Enabled := false;
    AMakePermanentas1.Caption := '&9  [no complex format]';

    if (ci <> nil) then begin
        b := ci.HasText;
        EditText1.Enabled := b;
        PasteusingMimicTyping1.Enabled := b;

        //N0PasteasRichText1.Enabled := not FrmConfig.cbPasteComplex.Checked;

        if ci.GetFormat = UnitMisc.GetCF_RICHTEXT then begin
            //N0PasteasRichText1.Caption := '&0  Paste as Rich Text';
            AMakePermanentas1.Enabled := true;
            AMakePermanentas1.Caption := '&9  as Rich Text';
        end else if ci.GetFormat = Windows.CF_UNICODETEXT then begin
            //N0PasteasRichText1.Caption := '&0  Paste as UNICODE';
            AMakePermanentas1.Enabled := true;
            AMakePermanentas1.Caption := '&9  as UNICODE';
        end else if (ci.GetFormat = Windows.CF_HDROP) then begin
            //N0PasteasRichText1.Caption := '&0  Paste as Files';
            AMakePermanentas1.Enabled := true;
            AMakePermanentas1.Caption := '&9  as Files';
        end else if (ci.GetFormat = UnitMisc.GetCF_HTML) then begin
            //N0PasteasRichText1.Caption := '&0  Paste as HTML';
            AMakePermanentas1.Enabled := true;
            AMakePermanentas1.Caption := '&9  as HTML';
        end else if (ci.GetFormat = Windows.CF_DIB) then begin
            //N0PasteasRichText1.Caption := '&0  Paste as HTML';
            AMakePermanentas1.Enabled := true;
            AMakePermanentas1.Caption := '&9  as Picture';
        end else
            if ci.HasText and
            (ci.GetFormat <> CF_DIB) and
            self.PermanentItemPressed then begin

        end;
    end else begin

    end;

    pmItemOptions.Items.RethinkHotkeys;
    if (s = '') and (ci <> nil) then begin
        s := ci.getastext;
    end;
    Run1.Caption := '&0  Run "'
        + LeftStr(self.GetTrimmedItem(s),25)
        + '..."';


    pmItemOptions.Popup(self.TargetX, self.TargetY );

    // make sure focus is returned
    if (self.ThreadAttach(self.HotKeyForeWindow)) then begin
        SetForegroundWindow(self.HotKeyForeWindow);
        self.ThreadDetach;
    end;
end;


/////////////////////////////////////////////////////////////////////////////
//
// ShowOnNextWindow - This lets another window cause the popup
// to show up on the text field that just lost focus
//

function TFrmMainPopup.GetNextWindow: THandle;
var h : THandle;
begin
    h := Windows.GetForegroundWindow;
    result := 0;

    if (h = 0) then begin
        UnitMisc.AppendLog('Can''t get foreground window', true);
        exit;
    end;
    h := Windows.GetNextWindow(h, GW_HWNDNEXT);
    if (h = 0) then begin
        UnitMisc.AppendLog('Can''t get next window', true);
        exit;
    end;

    while (not Windows.IsWindowVisible(h)) and (h <> 0) do begin
        h := Windows.GetNextWindow(h, GW_HWNDNEXT);
        if (h = 0) then begin
            UnitMisc.AppendLog('Can''t get next window in loop', true);
            exit;
        end;
    end;

    result := h;
end;

procedure TFrmMainPopup.ShowOnNextWindow(ShowPopup : boolean = true);
var h : THandle;
begin
    Windows.SetLastError(ERROR_SUCCESS);
    if (self.PopupShowing) then EXIT;
    self.PopupShowing := true;

    // find the current foreground window
    // find the "next" window (which means below the current, not above)
    // skip any invisible windows

    // move back the the "next" window and attempt
    // to make the previously focused control get keyboard focus again

    h := self.GetNextWindow;

    if (ShowPopup) then begin
        if (self.ThreadAttach(h)) then begin
            Windows.SetForegroundWindow(h);
            self.ThreadDetach;
        end else begin
            showmessage('Permission denied on target program.');
        end;
    end;

    self.HotKeyForeWindow := h;
    self.GatherTargetWindowData;
    self.FullMode := false;

    if (ShowPopup) then begin
        self.ShowPopupWithFocusRules;
    end;

    self.PopupShowing := false;
end;



function TFrmMainPopup.GetNextWindowProgramName: string;
var h : THandle;
begin
    Windows.SetLastError(ERROR_SUCCESS);

    h := self.GetNextWindow;
    // find the current foreground window
    // find the "next" window (which means below the current, not above)
    // skip any invisible windows
    {h := Windows.GetForegroundWindow;
    i := 0;
    while (h=0) and (i<10) do begin
        h := Windows.GetForegroundWindow;
        inc(i);
        sleep(20);
    end;
    if (h = 0) then begin
        UnitMisc.AppendLog('Can''t get foreground window', true);
    end;

    h := Windows.GetNextWindow(h, GW_HWNDNEXT);
    i := 0;
    while (h=0) and (i<10) do begin
        h := Windows.GetForegroundWindow;
        inc(i);
        sleep(20);
    end;
    if (h = 0) then begin
        UnitMisc.AppendLog('Can''t get next window', true);
    end;

    while (not Windows.IsWindowVisible(h)) and (h <> 0) do begin
        h := Windows.GetNextWindow(h, GW_HWNDNEXT);
        if (h = 0) then begin
            UnitMisc.AppendLog('Can''t get next window in loop', true);
        end;

    end;
    }
    if (h <> 0) then begin
        result := ExtractFilename(WindowHandleToEXEName(h));
    end else begin
        result := '';
    end;
end;



function TFrmMainPopup.GetSelectedText: string;
begin
    result := self.TargetSelText;
end;

procedure TFrmMainPopup.ShowOnSystemTray;
var h : THandle;
    CursorPos : TPoint;
begin
    Windows.SetLastError(ERROR_SUCCESS);
    if (self.PopupShowing) then EXIT;
    self.PopupShowing := true;


    Windows.GetCursorPos(CursorPos);

    // find the current foreground window
    // find the "next" window (which means below the current, not above)
    // skip any invisible windows

    {
    h := Windows.GetForegroundWindow;
    h := Windows.GetNextWindow(h, GW_HWNDNEXT);
    while not Windows.IsWindowVisible(h) do begin
        h := Windows.GetNextWindow(h, GW_HWNDNEXT);
    end;}

    h := self.GetNextWindow;

    self.HotKeyForeWindow := h;


    self.GatherTargetWindowData(h);
    self.HotKeyTarget := 0;
    self.TargetX := CursorPos.x;
    self.TargetY := CursorPos.Y;
    self.FullMode := false;

    Windows.SetForegroundWindow(self.Handle);
    self.ShowPopup(CursorPos.x, CursorPos.y);
    
    self.PopupShowing := false;
end;


procedure TFrmMainPopup.FullModeMenuItemClickEvent(Sender : TObject);
begin
    //
    // toggle Full->Configured and Configured->Full
    //
    self.FullMode := self.FullMode xor true;
    self.ShowPopupWithFocusRules;
end;






procedure TFrmMainPopup.SendText(s: string; ci : TClipItem = nil; NoPlaintext : boolean = false);
var prefix : string;
begin
    Windows.SetLastError(ERROR_SUCCESS);

    //
    // Since the popup may have stolen focus from the target,
    // it must be given keyboard focus again
    //
    if (self.PopupUseKB) then begin
        if (self.ThreadAttach(self.HotKeyForeWindow)) then begin
            Windows.SetForegroundWindow(self.HotKeyForeWindow);
            if (self.HotKeyTarget <> 0) then begin
                Windows.SetFocus(self.HotKeyTarget);
            end;
        end else begin
            //showmessage('ERROR: Unable to paste into target');
            //EXIT;
            Windows.SetForegroundWindow(self.HotKeyForeWindow);
        end;
    end;

    prefix :=uppercase(leftstr(s,6));

    if (prefix  = '[KEYS]') then begin
        Paste.SendTextWithKeystrokes(s);
    end else if (FrmPermanent.IsComplexItem(s)) then begin
        ci := FrmPermanent.GetComplexItem(s);

        Paste.SendText('', ci, NoPlaintext);
        MyFree(ci);
    end else begin
        Paste.SendText(s, ci, NoPlaintext);
    end;

    if (self.PopupUseKB) then begin
        self.ThreadDetach;
    end;
end;



{
--============================
-- // Thead utility methods //
--============================

Description: Mimic being part of the targeted window. This method is used
to get the keyboard focused item of an outside process and to associate a
popup menu with an outside process.

Update: Changed to allow ArsClip to paste into its own windows, like
Permanent Items.
}

function TfrmMainPopup.ThreadAttach(TargetWindow: cardinal) : boolean;
begin
    If (ThreadAttached) then begin
        showmessage('Error: Thread already attached');
        //self.Close;
    end;

    ThreadTarget := Windows.GetWindowThreadProcessId(TargetWindow, nil);
    ThreadOurs := Windows.GetCurrentThreadId();
    if (ThreadTarget <> ThreadOurs) then begin
        result := Windows.AttachThreadInput(ThreadTarget, ThreadOurs, true);
    end else begin
        result := true;
    end;
    ThreadAttached := result;
end;
procedure TfrmMainPopup.ThreadDetach();
begin
    if (ThreadTarget <> ThreadOurs) then begin
        Windows.AttachThreadInput(ThreadTarget, ThreadOurs, false);
    end;
    ThreadAttached := false;
end;




procedure TFrmMainPopup.timTimer(Sender: TObject);
var msg : TWMHotKey;
    hc : HCURSOR;

    tw : TTooltipWindow;
    p, oldp : TPoint;

    h : THandle;
    wp : TWindowPlacement;
    m : TMonitor;
    j : integer;
    i : integer;
    b : boolean;
    r : TRect;
    name : string;
    wi : tagWINDOWINFO;
    t1,t2 : cardinal;

    ShowPopup : boolean;
begin
    if not Assigned(frmSysTrayMenu) then EXIT;
    if not Assigned(frmConfig) then EXIT;
    if self.PopupActive  then EXIT;
    
    if KeyboardQuery.IsClicked(rightButton) then begin
        h := Windows.GetForegroundWindow;
        name := WindowHandleToEXEName(h);
        if frmSysTrayMenu.IsNoRightClickEXE(name)  then EXIT;

        oldP := Mouse.CursorPos;
        tim.Enabled := false;
        MySleep(FrmConfig.GetRightClickDelay);

        h := Windows.GetForegroundWindow;
        name := WindowHandleToEXEName(h);
        if GetWindowRect(h,r) then begin
            m := screen.MonitorFromRect(r);
            if m = nil then begin
                UnitMisc.AppendLog('MonitorFromRect failed', true);
                tim.Enabled := true;
                exit;
            end;

            UnitMisc.appendlog('RightClickTrigger monitor' + inttostr(m.boundsrect.Right) + ' ' + inttostr(m.boundsrect.bottom) );
            UnitMisc.appendlog('RightClickTrigger monitor' + inttostr(m.boundsrect.left) + ' ' + inttostr(m.boundsrect.top) );
            UnitMisc.appendlog('RightClickTrigger test ' + name  + inttostr(r.Right) + ' ' + inttostr(r.bottom) );
            UnitMisc.appendlog('RightClickTrigger test ' + name + inttostr(r.left) + ' ' + inttostr(r.top) );
            //UnitMisc.AppendLog('RightClickTrigger test ' + IntToStr(wp.showCmd));
            if ((r.Bottom-r.Top) >= (m.BoundsRect.Bottom-m.BoundsRect.top)) and
                ((r.Right-r.left) >= (m.boundsrect.Right-m.boundsrect.Left)) {and

                not (wp.showCmd in [SW_MAXIMIZE, SW_SHOWMAXIMIZED])}
            then begin
                UnitMisc.AppendLog('fullscreen detected');
                tim.Enabled := true;
                EXIT;
            end;



        end else begin
            UnitMisc.AppendLog('GetWindowRect failed', true);
        end;



        tw := TTooltipWindow.Create;

        if KeyboardQuery.IsClicked(rightButton) then begin
            ShowPopup := true;

            if not FrmConfig.GetRightclickTriggerWarned then begin
                KeyboardQuery.WaitUntilRelease(rightButton);


                if Dialogs.MessageDlg(
                    '(Setting: Configuration>Popup>Display Popup when Right-Click held down)'#13#10#13#10 +
                    'ArsClip is set by default to trigger the popup when the right mouse button is held. Keep this setting?'
                    ,
                    Dialogs.mtConfirmation, [mbYes, mbNo], 0
                ) = mrNo then begin
                    FrmConfig.cbRightTriggerEnable.Checked := false;
                end;
                FrmConfig.SetRightclickTriggerWarned;
                ShowPopup := false;
            end;

            if (abs(oldp.X-mouse.CursorPos.x) > 20) or
                (abs(oldp.Y-mouse.CursorPos.Y) > 20) then begin
                // ignore drag motions
                UnitMisc.AppendLog('drag detected');
                ShowPopup := false;
            end;


            //hc := CopyIcon(Screen.Cursors[crDefault]);
            //SetSystemCursor(Screen.Cursors[crHourGlass], OCR_NORMAL);

            //unitsound.PlaySound_NewClipboardItem;
            if showpopup then begin

            p := mouse.cursorpos;
                inc(p.x, 10);
                tw.ShowTooltip('Popup', p, false,'');
                KeyboardQuery.WaitUntilRelease(rightButton);
                tw.CloseTooltip();
                //Screen.Cursors[crDefault] := hc;
                //SetSystemCursor(hc, OCR_NORMAL);
                Paste.SendESC;
                msg.HotKey := FrmConfig.GetHotKeyID;
                self.UseMousePositionOnce := true;
                self.WMHotKey(msg);
            end;

        end;

        MyFree(tw);
        tim.Enabled := true;
    end;

end;

{
--===========
-- // Etc. //
--===========
}
procedure TfrmMainPopup.AppendLog(s : string);
begin
    if length(memo1.text) > 30000 then memo1.Text := '';
    // Cheezy Debugging Info[tm]
    // make sure we don't overflow the text, only accept 1000 characters
    // at a time
    memo1.Text := leftstr(s, 1000) + #13 + #10 + memo1.text;
end;

procedure TFrmMainPopup.ApplicationException(Sender: TObject; E: Exception);
begin
    UnitMisc.ApplicationException(Sender, E); 
end;

procedure TfrmMainPopup.btnHideClick(Sender: TObject);
begin
    self.Hide;                  
end;

procedure TFrmMainPopup.Button1Click(Sender: TObject);
var tt : TTooltipDragWindow;
begin
    tt := TTooltipDragWindow.Create;

    tt.ShowTooltip('test tooltip',mouse.CursorPos,false,'');


    //myfree(tt);
end;

{
--====================
-- CTRL option menu items
--===================
}
procedure TFrmMainPopup.Run1Click(Sender: TObject);
var i : integer;
begin
    Windows.SetLastError(ERROR_SUCCESS);
    //
    // try to run it as a mail address if it fails
    // the first time - report any error otherwise

    // trim any whitespace - CRLFs
    i := UnitMisc.ShellExecute(self.Handle, self.MenuItemText);
    if i <> 0 then begin
        ShowMessage(SysErrorMessage(i) );
    end;
end;

procedure TFrmMainPopup.MakePermanentItem1Click(Sender: TObject);
begin
    Windows.SetForegroundWindow(FrmPermanent.Handle);
    frmPermanent.ShowWithNewItem(self.MenuItemText);
end;


procedure TFrmMainPopup.AMakePermanentas1Click(Sender: TObject);
begin
    Windows.SetForegroundWindow(FrmPermanent.Handle);
    frmPermanent.ShowWithNewComplexItem(self.CTRLClickedItem);
end;


procedure TFrmMainPopup.PasteusingMimicTyping1Click(Sender: TObject);
begin
    Paste.SetKeyboardMimicOnce;
    self.SendText(self.MenuItemText);
end;

procedure TFrmMainPopup.Placeonclipboard1Click(Sender: TObject);
var i : integer;
    ci : TClipItem;
begin
    //
    // always default to the Unicode version, if available
    //
    Paste.SetClipboardOnlyOnce;
    i := ClipQueue.IndexOf(self.MenuItemText);
    ci := ClipQueue.GetClipItem(i);
    if (ci <> nil) then begin
        if (ci.GetFormat = CF_UNICODETEXT) then begin
            self.SendText('',ci);
            EXIT;
        end;
    end;

    self.SendText(self.MenuItemText);
end;

procedure TFrmMainPopup.Preview1Click(Sender: TObject);
begin
    if self.CTRLClickedItem <> nil then begin
        if self.CTRLClickedItem.GetFormat = UnitMisc.GetCF_RICHTEXT then begin
            self.CTRLClickedItem.GetRichText(self.menuitemtext);
            FrmPreview.SetRichText(self.MenuItemText);
            self.ShowPreviewForm;

            EXIT;
        end;
        if self.CTRLClickedItem.GetFormat = CF_DIB then begin
            FrmPreview.SetPicture;

            FrmPreview.SetPicture;
            self.CTRLClickedItem.GetDIB(FrmPreview.imgPreview.picture);
            self.ShowPreviewForm;
            EXIT;
        end;
    end;
    FrmPreview.SetText(self.MenuItemText);

    self.ShowPreviewForm;
end;

procedure TFrmMainPopup.EditText1Click(Sender: TObject);
var s : string;
begin
    if self.CTRLClickedItem = nil then begin
        s := MenuItemText;
    end else begin

        if self.CTRLClickedItem.GetFormat = UnitMisc.GetCF_RICHTEXT then begin
            self.CTRLClickedItem.GetRichText(s);
        end else begin
            s := self.CTRLClickedItem.GetAsText;
        end;
    end;
    FrmEditItem.SetText(s, nil);
    self.ShowPreviewEditForm;
end;


procedure TFrmMainPopup.back1Click(Sender: TObject);
begin
    self.ShowPopupWithFocusRules;
end;

procedure TFrmMainPopup.PasteusingSHIFTINS1Click(Sender: TObject);
begin
    Paste.SetUsePasteSIOnce;
    if self.CTRLClickedItem.HasText then begin
        self.SendText(self.MenuItemText);
    end else begin
        self.SendText('',self.CTRLClickedItem);
    end;
end;

procedure TFrmMainPopup.PasteusingCTRLV1Click(Sender: TObject);
begin
    Paste.SetUsePasteCVOnce;
    if self.CTRLClickedItem.HasText then begin
        self.SendText(self.MenuItemText);
    end else begin
        self.SendText('',self.CTRLClickedItem);
    end;
end;

procedure TFrmMainPopup.N0RemoveItemClick(Sender: TObject);
var i : integer;
begin
    // Paste as Plain text when Complex is default
    // Paste as Rich Text when not using Complex by default
    {if (FrmConfig.cbPasteComplex.Checked) then begin
        Paste.SendText(self.MenuItemText, nil);
    end else begin
        Paste.SendText(self.MenuItemText, self.CTRLClickedItem, true);
    end;
    }

    if (self.CTRLClickedItem <> nil) then begin
        i := ClipQueue.IndexOf(self.CTRLClickedItem);
        if (i <> -1) then
            ClipQueue.DeleteItem(i);
    end;
    self.ShowPopupWithFocusRules;
end;


function TFrmMainPopup.GetLastStringSelected: string;
begin
    result := self.LastStringSelected;
end;
function TFrmMainPopup.GetUseFormMode: boolean;
begin
    result := self.UseFormMode;
end;
function TFrmMainPopup.GetFullMode: boolean;
begin
    result := self.FullMode;
end;
function TFrmMainPopup.GetDoMoveSelectedToTop: boolean;
begin
    result := DoMoveSelectedToTop;
end;
function TFrmMainPopup.GetDoRememberHistory: boolean;
begin
    result := DoRememberHistory;
end;
function TFrmMainPopup.GetDoShowCurrentItem: boolean;
begin
    result := DoShowCurrentItem;
end;
function TFrmMainPopup.GetDoShowEditHistory: boolean;
begin
    result := DoShowEditHistory;
end;
function TFrmMainPopup.GetDoShowFormMode: boolean;
begin
    result := DoShowFormMode;
end;
function TFrmMainPopup.GetDoShowLast: boolean;
begin
    result := DoShowLast;
end;
function TFrmMainPopup.GetDoShowPasteAll: boolean;
begin
    result := DoShowPasteAll;
end;
function TFrmMainPopup.GetDoShowPermanentItemGroups: boolean;
begin
    result := DoShowPermanentItemGroups;
end;
function TFrmMainPopup.GetDoShowPermanentItemSubmenu: boolean;
begin
    result := DoShowPermanentItemSubmenu
end;
function TFrmMainPopup.GetUsePermanentItems: boolean;
begin
    result := UsePermanentItems;
end;





procedure TFrmMainPopup.MimicTyping1Click(Sender: TObject);
begin
    Paste.AssignPaste(self.TargetEXE, PASTE_MIMIC);
end;

procedure TFrmMainPopup.N2SHIFTINSERT1Click(Sender: TObject);
begin
    Paste.AssignPaste(self.TargetEXE, PASTE_SHIFT_INS);
end;

procedure TFrmMainPopup.N3CTRLV1Click(Sender: TObject);
begin
    Paste.AssignPaste(self.TargetEXE, PASTE_CTRL_V);
end;

procedure TFrmMainPopup.N4ClipboardOnly1Click(Sender: TObject);
begin
    Paste.AssignPaste(self.TargetEXE, PASTE_CLIPBOARD);
end;

procedure TFrmMainPopup.N5Default1Click(Sender: TObject);
begin
    Paste.AssignPaste(self.TargetEXE, PASTE_DEFAULT);
end;







procedure TFrmMainPopup.ShowPreviewEditForm;
begin
    Windows.SetForegroundWindow(FrmEditItem.Handle);

    FrmEditItem.Left := Self.TargetX;
    FrmEditItem.Top := Self.TargetY;
    FrmEditItem.ShowModal;
    //self.ShowPopupWithFocusRules;
end;

procedure TFrmMainPopup.N0UndeleteItemClick(Sender: TObject);
var i : integer;
begin
    //Paste.SendText(self.CTRLClickedItem.GetAsText, nil);

    if self.CTRLClickedItem <> nil then begin
        i := TempClipQueue.IndexOf(self.CTRLClickedItem);
        if (i <> -1) then begin
            TempClipQueue.DeleteItem2(i,true);
            ClipQueue.InsertAtStart(self.CTRLClickedItem);
            // delete without a free
        end;
    end;
    self.ShowPopupWithFocusRules;
end;



end.
