unit UnitFrmPermanentEdit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, ComCtrls, Buttons, UnitClipQueue, Menus,
  UnitFrmHotKey, UnitFrmPermanentNew;

type
  TFrmPermanentEdit = class(TForm)
    GroupBox1: TGroupBox;
    pnlKeys: TPanel;
    Label6: TLabel;
    lblKeyname: TLabel;
    Shape1: TShape;
    bEditHotkey: TButton;
    btnClear: TButton;
    btnSave: TButton;
    btnCancel: TButton;
    GroupBox2: TGroupBox;
    Label4: TLabel;
    bGetClipboardAs: TBitBtn;
    txtItemName: TEdit;
    Label3: TLabel;
    Label2: TLabel;
    pnlItem: TPanel;
    pPreview: TImage;
    reItemText: TRichEdit;
    mItemText: TMemo;
    pmGetAs: TPopupMenu;
    PlaintText1: TMenuItem;
    DIBPicture1: TMenuItem;
    CopiedFiles1: TMenuItem;
    RichTExt1: TMenuItem;
    cbKeystrokes: TCheckBox;
    Panel1: TPanel;
    btnWait: TButton;
    Button12: TButton;
    Button13: TButton;
    Button14: TButton;
    Button16: TButton;
    Panel2: TPanel;
    Button10: TButton;
    Button11: TButton;
    Button15: TButton;
    Panel3: TPanel;
    Button1: TButton;
    Button5: TButton;
    Button2: TButton;
    Button3: TButton;
    Button6: TButton;
    Button4: TButton;
    Button7: TButton;
    Button9: TButton;
    Button8: TButton;
    SpeedButton1: TSpeedButton;
    pmSaveGroup: TPopupMenu;
    Button17: TButton;
    procedure cbKeystrokesClick(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure btnSaveClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure bGetClipboardAsClick(Sender: TObject);
    procedure bEditHotkeyClick(Sender: TObject);
    procedure btnClearClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SpeedButton1Click(Sender: TObject);
    procedure GroupMenuClick(Sender: TObject);

  private
    { Private declarations }
    clip : TClipItem;
    IsNew : boolean;
    index : integer;
    group : string;
    overridegroup : string;
    clipformat : integer;
    hkd : THotkeyData;

    HasNewData : boolean;
    NewDatIsClip : boolean;


    procedure ShowItem(ci : TClipItem); overload;
  public
    { Public declarations }
    function ShowForm(
        asnew : boolean;
        group : string; itemindex : integer;hotkey : THotKeyData;
        ci : TClipItem = nil ) : integer; overload;

    function ShowForm(
        asnew : boolean;
        group : string; itemindex : integer;
        ci : TClipItem = nil ) : integer; overload;

    procedure SetNewItem( s : string ); overload;
    procedure SetNewItem( ci : TClipItem ); overload;

    procedure PopupItemClick(sender : Tobject);
  end;

var
  FrmPermanentEdit: TFrmPermanentEdit;

implementation

uses  Clipbrd, UnitMisc, UnitTWideChar, StrUtils;

{$R *.dfm}



procedure TFrmPermanentEdit.cbKeystrokesClick(Sender: TObject);
var i, j : integer;
begin
    for i := 0 to pnlKeys.ControlCount  - 1 do begin
        if  pnlkeys.Controls[i] is TPanel then begin
            for j := 0 to TPanel(pnlkeys.Controls[i]).ControlCount - 1 do   begin
                TPanel(pnlkeys.Controls[i]).Controls[j].Enabled := cbKeystrokes.Checked;
            end;
        end;

    end;
end;

procedure TFrmPermanentEdit.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
    self.HasNewData := false;
    self.NewDatIsClip := false;
end;

procedure TFrmPermanentEdit.FormCreate(Sender: TObject);
begin
    clip := TClipItem.Create;
end;


procedure TFrmPermanentEdit.GroupMenuClick(Sender: TObject);
begin
    self.overridegroup := TMenuItem(sender).caption;
end;

procedure TFrmPermanentEdit.PopupItemClick(sender: Tobject);
begin
    with sender as TMenuItem do begin
        clipformat := StrToInt(Hint);
    end;
    clip.GetClipboardItem(0, clipformat);

    self.ShowItem(clip);
end;


procedure TFrmPermanentEdit.SetNewItem(s: string);
begin
    self.HasNewData := true;
    self.mItemText.text := s;
    self.clipformat := CF_TEXT;
    self.NewDatIsClip := false;
end;

procedure TFrmPermanentEdit.SetNewItem(ci: TClipItem);
begin

end;

function TFrmPermanentEdit.ShowForm(asnew : boolean; group: string; itemindex: integer; ci : TClipItem = nil  ) : integer;
var hk : THotkeyData;
begin
    hk.name := EMPTY_HOTKEY_NAME;
    self.ShowForm(asnew,group,itemindex,hk,ci);

    result := 0; // not used yet
end;

function TFrmPermanentEdit.ShowForm(
        asnew : boolean;
        group : string; itemindex : integer;hotkey : THotKeyData;
        ci : TClipItem = nil ) : integer;
var s : string;
    prefix : string;
procedure RefreshPopup;
    var i : integer;
    cur, s : string;
    mi : TMenuItem;
begin
    pmSaveGroup.Items.Clear;
    if self.overridegroup = '' then self.overridegroup := self.group;
    cur := self.overridegroup;



    for i  := 0 to FrmPermanent.PermFoldersGetCount - 1 do begin
        s := FrmPermanent.PermFoldersGetItem(i);
        mi := pmSaveGroup.CreateMenuItem;
        mi.Caption := s;
        if (s = cur) then begin
            mi.Checked := true;
        end;
        mi.OnClick := self.GroupMenuClick;

        pmSaveGroup.Items.add(mi);
    end;
end;

begin
    self.overridegroup := group;
    //RefreshPopup;
    FrmPermanent.PermFolderPush;
    clip.GetClipboardItem(0);

    mItemText.Visible := false;
    reItemText.Visible := false;
    pPreview.Visible := false;

    self.IsNew := asnew;
    self.index := ItemIndex;
    self.group := group;
    //self.overridegroup := '';
    self.clipformat := CF_TEXT;
    cbKeystrokes.Checked := false;
    self.hkd := hotkey;
    lblKeyname.Caption := hkd.name;
    FrmPermanent.SetPermanentPath(group);

    if self.IsNew then begin
        txtItemName.text := '';
        if not self.HasNewData then begin
            self.clipformat := CF_TEXT;
            mItemText.Lines.clear;
        end else begin
            if FrmPermanent.IsComplexItem(mItemText.Text) then begin
                ci := FrmPermanent.GetComplexItem(mItemText.text);
                self.clipformat := ci.GetFormat;
            end;
        end;
        mItemText.Visible := true;
        lblKeyname.Caption := EMPTY_HOTKEY_NAME;
        if (ci <> nil) then begin
            self.ShowItem(ci);
            MyFree(clip);
            clip := ci;
        end;
    end else begin
        lblKeyname.caption := hotkey.name;
        s := FrmPermanent.GetItemText(self.index);
        if FrmPermanent.IsComplexItem(s) then begin
            ci := FrmPermanent.GetComplexItem(s);
            self.ShowItem(ci);
        end else begin
            txtItemName.text := '';
            mItemText.Lines.clear;
            mItemText.Visible := true;
            mItemText.Text := s;
        end;
        txtItemName.text := FrmPermanent.GetItemName(self.index);

        prefix := uppercase(leftstr(mItemText.Text,6));
        cbKeystrokes.Checked :=  prefix = '[KEYS]';
        if cbKeystrokes.Checked then begin
            s := mItemText.Text;
            delete(s,1,6);
            mItemText.Text := s;
        end;
    end;
    FrmPermanent.PermFolderPop;
    result := self.ShowModal;
end;

procedure TFrmPermanentEdit.ShowItem(ci: TClipItem);
var
  wc: TWideChar;
  r : TRect;
  s : string;
begin
    pPreview.Visible := false;
    mItemText.Visible := false;
    reItemText.Visible := false;

    clipformat := ci.getformat;


    if (ci.GetFormat = Windows.CF_DIB) then begin
        pPreview.Visible := true;
        ci.GetDIB(pPreview.Picture);
    end else if (ci.GetFormat = unitmisc.GetCF_RICHTEXT)
        or (ci.GetFormat = unitmisc.GetCF_HTML) then begin
        reItemText.Visible := true;
        reItemText.PlainText := false;
        reItemText.Lines.Clear;
        ci.GetRichText(s);
        reItemText.Text := s;
    end else if (ci.GetFormat = Windows.CF_UNICODETEXT) then begin

        pPreview.Visible := true;
        wc := TWideChar.Create;
        wc.append(ci.GetHandle, ci.GetDataSize);

        // if only it was really this easy, jeez
        {
        mItemText.Visible := true;

        mitemtext.Text := '';
        Windows.SetWindowTextW(mItemText.Handle, PWideChar(wc.Memory) );
        }

        pPreview.Canvas.textflags := pPreview.Canvas.textflags or DT_WORDBREAK and (not DT_SINGLELINE);
        r := pPreview.ClientRect;
        FillRect(pPreview.Canvas.handle,r,pPreview.Canvas.brush.handle);
        DrawTextW(
            pPreview.Canvas.handle, wc.memory, (wc.size-2) div 2,
            r, DT_WORDBREAK
        );

        //lblClipType.Caption := lblClipType.Caption + ' - item contents read only ';

        myfree(wc);
    end else begin
        clipformat := CF_TEXT;
        mItemText.Visible := true;
        mitemtext.Text := Clipboard.AsText;
    end;
end;

procedure TFrmPermanentEdit.SpeedButton1Click(Sender: TObject);
var i : integer;
    cur, s : string;
    mi : TMenuItem;
begin
    pmSaveGroup.Items.Clear;
    if self.overridegroup = '' then self.overridegroup := self.group;
    cur := self.overridegroup;



    for i  := 0 to FrmPermanent.PermFoldersGetCount - 1 do begin
        s := FrmPermanent.PermFoldersGetItem(i);
        mi := pmSaveGroup.CreateMenuItem;
        mi.Caption := s;
        if (s = cur) then begin
            mi.Checked := true;
        end;
        mi.OnClick := self.GroupMenuClick;

        pmSaveGroup.Items.add(mi);
    end;


    pmSaveGroup.Popup(mouse.CursorPos.X + 4, mouse.cursorpos.y + 4);
end;

procedure TFrmPermanentEdit.bEditHotkeyClick(Sender: TObject);
begin
    if FrmHotkey.GetHotkey(
        hkd.alt, hkd.shft, hkd.ctrl, hkd.win,
        hkd.key,
        hkd.name
    ) then begin
        //ItemHotKeyList[lbItemNames.ItemIndex] := self.ToString(hkd);
        lblKeyname.Caption := hkd.name;
    end;
end;

procedure TFrmPermanentEdit.bGetClipboardAsClick(Sender: TObject);
var mi : TMenuItem;
    p : TPoint;
    procedure AddFormat(format : integer; description : string);
    begin
        if Clipbrd.clipboard.HasFormat(format) then begin
            mi := TMenuItem.Create(pmGetAs);
            mi.Caption := description;
            mi.Hint := IntToStr(format);
            mi.OnClick := self.PopupItemClick;
            pmGetAs.Items.Add(mi);
        end;

    end;
begin
    pmGetAs.Items.Clear;
    AddFormat(CF_TEXT, 'Plain Text');
    AddFormat(CF_WAVE, 'Wave Audio');
    AddFormat(CF_DIB, 'DIB (Picture)');
    AddFormat(CF_HDROP, 'File(s)');
    AddFormat(UnitMisc.GetCF_RICHTEXT, 'RichText');
    AddFormat(UnitMisc.GetCF_HTML, 'HTML');
    AddFormat(CF_UNICODETEXT, 'Unicode');

    Windows.ClientToScreen(bGetClipboardAs.Handle, p);
    pmGetAs.Popup(mouse.CursorPos.X + 4, mouse.cursorpos.y + 4);
end;





procedure TFrmPermanentEdit.btnClearClick(Sender: TObject);
begin
    lblKeyname.caption := EMPTY_HOTKEY_NAME;
    hkd.name := '';
    hkd.alt := false;
    hkd.ctrl := false;
    hkd.shft := false;
    hkd.win := false;
    hkd.key := 0;
end;

procedure TFrmPermanentEdit.btnSaveClick(Sender: TObject);
var c : TClipItem;
    wc : TWideChar;
    l : integer;
begin
    c := nil;
    if self.clipformat <> CF_TEXT then c := self.clip;

    {
    // the TEdit isn't playing nice
    if self.clipformat = CF_UNICODETEXT then begin
        l := Windows.GetWindowTextLengthW(mItemText.Handle);
        wc.GetMemoryStream.SetSize(l);
        Windows.GetWindowTextW(mItemText.Handle, wc.Memory, l);

        c := TClipItem.Create;
        c.SetFromWideChar(wc);
    end;
    }

    // if the group changed, just save to the end of the list
    if (self.group <> self.overridegroup) then begin
        self.index := -1;
        self.group := self.overridegroup;
    end;


    if (self.IsNew) then begin
        FrmPermanent.SaveNewItem(
            self.group,txtItemName.Text,mItemText.Text,
            hkd,cbKeystrokes.checked,c
        );
    end else begin
        FrmPermanent.SaveItem(
            self.group,self.index, txtItemName.Text,mItemText.Text,
            hkd,cbKeystrokes.checked,c
        );
    end;
    self.ModalResult := mrOK;
end;

procedure TFrmPermanentEdit.btnCancelClick(Sender: TObject);
begin
    self.ModalResult := mrCancel;
end;

procedure TFrmPermanentEdit.Button1Click(Sender: TObject);
var btn : TButton;
begin
    btn := TButton(sender);
    if mItemText.SelStart = 0 then
        mItemTExt.SelStart := length(mItemText.Text);

    if (btn.caption = 'DATE') then begin
        mItemText.SelText := '[' + btn.Caption + '="mm/dd/yyyy"]';
    end else if (btn.caption = 'POPUPITEM') then begin
        mItemText.SelText := '[' + btn.Caption + '="0"]';
    end else begin
        mItemText.SelText := '[' + btn.Caption + ']';
    end;

end;

end.
