unit UnitSound;

{///////////////}
{//}interface{//}
{///////////////}
procedure PlaySound_NewClipboardItem;
procedure PlaySound_Init;
{////////////////////}
{//}implementation{//}
{////////////////////}

uses Registry, Windows, MMSystem, UnitFrmConfig;

var r : TRegistry;

const AC_APPNAME = 'ArsClip';
const AC_NEWCLIPBOARDITEM = AC_APPNAME + '_NewClipboardItem';
const AC_NEWCLIPBOARDITEM_VALUE = 'New Clipboard Item';


procedure PlaySound_NewClipboardItem();
begin
    MMSystem.PlaySound(
        AC_NEWCLIPBOARDITEM,
        0,
        SND_APPLICATION or SND_ASYNC or SND_NODEFAULT
    );
end;

procedure SetAppEventKey(key, name, value : string; cancreate : boolean = false; expanded : boolean = false);
var s : string;
begin
    r.RootKey := HKEY_CURRENT_USER;
    s := '\AppEvents\';

    s := s + key;

    if (r.OpenKey(s, cancreate)) then begin
        if (expanded) then begin
            r.WriteExpandString(name, value);
        end else begin
            r.WriteString(name, value);
        end;
        r.CloseKey;
    end;
end;

procedure PlaySound_Init;
begin
    if FrmConfig.cbEnableSound.Checked then begin
        r := TRegistry.Create();
        SetAppEventKey('EventLabels\' + AC_NEWCLIPBOARDITEM, '', AC_NEWCLIPBOARDITEM_VALUE , true);
        SetAppEventKey('Schemes\Apps\' + AC_APPNAME, '', AC_APPNAME, true);
        SetAppEventKey('Schemes\Apps\' + AC_APPNAME +'\' + AC_NEWCLIPBOARDITEM, '', AC_NEWCLIPBOARDITEM_VALUE, true);
    end;
end;


initialization
begin

end;

end.
